#include <iostream>
#include <cstdio>
#include <cmath>
#include <algorithm>
#include <set>
#include <map>
#include <queue>
#include <cstdlib>
#include <string>
#include <string.h>
#include <vector>
#include <ctime>
#include <cassert>

using namespace std;

#define ll long long
#define ld long double
#define mp make_pair
#define pb push_back
#define y0 askjdfghjksdf
#define y1 askldjfahsd
#define fst first
#define snd second

template<typename T> T abs(T x) {if (x>=0) return x; return -x;}

bool cw(const pair < ll, ll > &a, const pair < ll, ll > &b, const pair < ll, ll > &c)
{
	return a.fst * (b.snd - c.snd) + b.fst * (c.snd - a.snd) + c.fst * (a.snd - b.snd) > 0;
}

bool ccw(const pair < ll, ll > &a, const pair < ll, ll > &b, const pair < ll, ll > &c)
{
	return a.fst * (b.snd - c.snd) + b.fst * (c.snd - a.snd) + c.fst * (a.snd - b.snd) < 0;
}

const int maxn = 100005;

int ans[maxn];

void hull(const vector < pair < pair < ll, ll >, int > > &a, int iter)
{
	if (a.size() == 1)
	{
		ans[a[0].snd] = iter;
		return;
	}

	vector < pair < pair < ll, ll >, int > > up, down;
	up.pb(a[0]);
	down.pb(a[0]);

	int n = a.size();

	for (int i = 1; i < n; i++)
	{
		if (i == n - 1 || !ccw(a[0].fst, a[i].fst, a[n - 1].fst))
		{
			while (down.size() > 1 && ccw(down[down.size() - 2].fst, down.back().fst, a[i].fst))
				down.pop_back();
			down.pb(a[i]);
		}

		if (i == n - 1 || !cw(a[0].fst, a[i].fst, a[n - 1].fst))
		{
			while (up.size() > 1 && cw(up[up.size() - 2].fst, up.back().fst, a[i].fst))
				up.pop_back();
			up.pb(a[i]);
		}
	}

	for (auto x : up)
		ans[x.snd] = iter;
	for (auto x : down)
		ans[x.snd] = iter;
}

struct Point
{
private:
	double x, y, z;
public:
	Point(double x, double y, double z) : x(x), y(y), z(z){};

	Point operator-(Point p)
	{
		return Point(x - p.x, y - p.y, z - p.z);
	}

	double operator %(Point p)
	{
		return x * p.x + y * p.y + z * p.z;
	}

	Point operator *(Point p)
	{
		return Point(y * p.z - z * p.y, z * p.x - x * p.z, x * p.y - y * p.x);
	}

	double length()
	{
		return sqrt(x * x + y * y + z * z);
	}
};

double x[11], y[11], z[11];

double myccw(Point p1, Point p2, Point p3)
{
	return (p1 * p2) % p3;
}

double getans(int i, int j, int k)
{
	Point p1 = Point (x[i], y[i], z[i]), p2 = Point (x[j], y[j], z[j]), p3 = Point(x[k], y[k], z[k]), p4 = Point(x[0], y[0], z[0]);
	Point v1 = p2 - p1, v2 = p3 - p1, v3 = p4 - p1;
	return abs(myccw(v1, v2, v3) / (v1 * v2).length());
}

int main()
{
	//freopen("a.in", "r", stdin);
	
	int m, h, H;
	cin >> m >> h >> H;
	for (int i = 0; i <= 4; i++)
		cin >> x[i] >> y[i];
	z[4] = H;
	z[0] = h;
	double mini = min(min(getans(1, 2, 3), getans(1, 2, 4)), min(getans(1, 3, 4), getans(2, 3, 4)));
	if (mini + h - 1e-9 <= m)
		cout << "YES\n";
	else
		cout << "NO\n";
	return 0;
}