#include <iostream>
#include <cstdio>
#include <string>
#include <cstring>
#include <map>
#include <set>
#include <stack>
#include <queue>
#include <vector>
#include <cmath>
#include <algorithm>
#include <ctime>
#include <cstdlib>
#include <cassert>

using namespace std;
#define forn(i, n) for (int i = 0; i < n; ++i)
#define ALL(a) a.begin(), a.end()
#define X first
#define Y second
#define sz(a) ((int)a.size())
#define L(a) sz(a)
#define pb(a) push_back(a)
#define mp(a, b) make_pair(a, b)
#define ms(a) memset(a,0,sizeof(a))
#define ms1(a) memset(a,-1,sizeof(a))

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair<double, double> pii;

const double PI = 3.1415926535897932384626433832795;

const double eps = 1e-9;

int cmp(double x, double y) {
	if (fabs(x-y) <= eps) return 0;
	if (x-y < 0) return -1;
	return 1;
}

double mySqrt(double x) {
	if (x < 0) return 0;
	return sqrt(x);
}

struct point {
	double x, y, z;
	point():x(0),y(0),z(0) {}
	point(double x, double y, double z):x(x),y(y),z(z) {}

	point operator+(const point& o) const {
		return point(x+o.x,y+o.y,z+o.z);
	}

	point operator-(const point& o) const {
		return point(x-o.x,y-o.y,z-o.z);
	}

	point operator*(double k) const {
		return point(x*k,y*k,z*k);
	}

	double length() const {
		return mySqrt(*this % *this);
	}

	double operator%(const point& o) const {
		return x*o.x+y*o.y+z*o.z;
	}
	point operator*(const point& o) const {
		return point(y*o.z-z*o.y, z*o.x-x*o.z, x*o.y-y*o.x);
	}

	point setlength(double k = 1) const {
		return *this * (k/length());
	}
	
	double disttoplane(const point& p1, const point& p2, const point& p3) const {
		point n = (p2-p1)*(p3-p1);
		n = n.setlength();
		double res = (*this - p1) % n;
		return fabs(res);
	}
	void scan() {
		scanf("%lf%lf%lf", &x, &y, &z);
	}
};

double vect(const pii& p1, const pii& p2) {
	return p1.X*p2.Y-p1.Y*p2.X;
}

double dist(const pii& p) {
	return p.X*p.X+p.Y*p.Y;
}

bool cmp1(const pii& p1, const pii& p2) {
	double vv = vect(p1, p2);
	if (cmp(vv, 0) > 0) return true;
	if (cmp(vv, 0) == 0) return dist(p1) < dist(p2);
	return false;
}

double solve(vector<pii> v) {
	
	sort(ALL(v));
	v.erase(unique(ALL(v)), v.end());
	int n = sz(v);
	if (n <= 2) return 0;
	
	/*int pos = min_element(ALL(v))-v.begin();
	swap(v[0], v[pos]);*/
	for (int i = n-1; i >= 0; --i) v[i].X -= v[0].X, v[i].Y -= v[0].Y;
	sort(ALL(v), cmp1);
	
	stack<pii> st;
	st.push(v[0]);
	for(int i = 1; i < n; ++i) {
		pii cur = v[i];
		while (sz(st) > 1) {
			pii pr = st.top(); st.pop();
			pii ppr = st.top();
			st.push(pr);
			double cv = vect(mp(pr.X-ppr.X,pr.Y-ppr.Y), mp(cur.X-pr.X,cur.Y-pr.Y));
			if (cmp(cv,0) <= 0) st.pop();
			else break;
		}
		st.push(cur);
	}
	vector<pii> pts;
	while (!st.empty()) pts.pb(st.top()), st.pop();
	reverse(ALL(pts));
	int cc = sz(pts);
	//pts.pb(pts[0]);
	double res = 0;
	for (int i = 1; i < cc-1; ++i) {
		res += vect(pts[i], pts[i+1]);
	}
	return fabs(res)/2;
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else
	freopen("aerodynamics.in", "r", stdin);
	freopen("aerodynamics.out", "w", stdout);
#endif
	int n, zmin, zmax; scanf("%d%d%d", &n, &zmin, &zmax);
	vector<point> v(n);
	forn(i, n) v[i].scan();
	for (int z = zmin; z <= zmax; ++z) {
		vector<pii> pts;
		forn(i, n) forn(j, n) {
			if (i == j) continue;
			if (cmp(v[i].z, z) > 0) continue;
			if (cmp(v[j].z, z) < 0) continue;
			point V = v[j]-v[i];
			double k = 0;
			if (cmp(v[i].z, v[j].z) != 0) k = (z-v[i].z)/(v[j].z-v[i].z);
			point cur = v[i] + V*k;
			pts.pb(mp(cur.x, cur.y));
		}
		double ans = solve(pts);
		printf("%.15lf\n", ans);
	}
	return 0;
}


