#include <cstdio>
#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <map>
#include <cstring>
#include <string>
#include <set>
#include <iomanip>
using namespace std;
typedef long long LL;
typedef pair<int,int> PII;
typedef vector<int> VI;
#define fname ""
#define pb push_back
#define F first
#define S second
#define mp make_pair
#define forit(it, s) for(__typeof(s.begin()) it = s.begin(); it != s.end(); it++)
#define all(s) s.begin(),s.end()
#define sqr(x) (x)*(x)
const int maxn = (int)1e5;
const int maxsz = (int)500;
const int inf = (1 << 30) - 1;
const double badP = 12345676543.0;
const double eps = 1e-9;
const int mag = 101;
struct point {
	double x, y;
	point () : x(0), y(0) {}
	point (double x, double y) : x(x), y(y) {}
	double mod2() {return x * x + y * y;}
	double mod() {return sqrt(mod2());}
	double ang() {return atan2(y, x);}
	double dist(point p) {return sqrt(sqr(x - p.x) + sqr(y - p.y));}
	point const operator + (const point &p) const {
		return point(x + p.x, y + p.y);
	}
	point const operator - (const point &p) const {
		return point(x - p.x, y - p.y);
	}
	point const operator * (double k) const {
		return point(x * k, y * k);
	}
	point const operator / (double k) const {
		return point(x / k, y / k);
	}
	double const operator * (const point &p) const {
		return x * p.x + y * p.y;
	}
	void const operator *= (double k)  {
		x *= k, y *= k;
	}
	void const operator /= (double k) {
		x /= k, y /= k;
	}

	bool const operator < (const point &p) const {
		if (x == p.x) return y < p.y;
		return x < p.x;
	}
	bool const operator == (const point &p) const {
		return x == p.x && y == p.y;
	}
	void rotat(double alpha) {
		double M = mod(), beta = ang();
		alpha += beta;
		x = M * cos(alpha);
		y = M * sin(alpha);
	}
};

double vect(point a, point b) {
	return a.x * b.y - a.y * b.x;
}

int h, n, N, zmin, zmax;
point st[maxn], a[maxn];
vector <point> hull, p[205];


point local[maxn];
int cnt[maxsz], head[maxsz];
void sort_(point *s, point *f) {
	for (int i = 0; i < maxsz; ++i)
		cnt[i] = 0;
	head[0] = 0;
	for (point *it = s; it != f; ++it)
		cnt[(int)it -> y]++;
	int *it1 = head, *it2 = cnt;
	for (int i = 1; i < maxsz; ++i) {
		head[i] = *it1 + *it2;
		++it1, ++it2;
	}
	for (point *it = s; it != f; ++it)
		local[head[(int)it -> y]++] = *it;
	int mal = 0;
	for (point *it = s; it != f; ++it, ++mal)
		*it = local[mal];

	for (int i = 0; i < maxsz; ++i)
		cnt[i] = 0;
	head[0] = 0;
	for (point *it = s; it != f; ++it)
		cnt[(int)it -> x]++;
	it1 = head, it2 = cnt;
	for (int i = 1; i < maxsz; ++i) {
		head[i] = *it1 + *it2;
		++it1, ++it2;
	}
	for (point *it = s; it != f; ++it)
		local[head[(int)it -> x]++] = *it;
	mal = 0;
	for (point *it = s; it != f; ++it, ++mal)
		*it = local[mal];

	return;
}

void build() {
	h = 0;
	for (int i = 0; i < n; i++) {
		while (h >= 2 && vect(st[h-1] - st[h-2], a[i] - st[h-2]) < eps)  h--;
		st[h++] = a[i];
	}
	h--;
	for (int i = 0; i < h; i++) hull.push_back(st[i]);
}

double solve() {
	sort(a, a + n); 
//	n = unique(a, a + n) - a;
	hull.clear();
	build(); reverse(a, a + n);
	build(); reverse(a, a + n);
	
	double S = 0;
	int sz = hull.size();
//	cout << sz << endl;
//	forit (vv, hull) {
//	    cout << vv->x << " " << vv->y << "\n";
//	}
	for(int i = 0; i < sz; i++)
		S += vect(hull[i], hull[(i + 1) % sz]);
	return fabs(S) / 2;
}

point inter(point a, point b, double az, double bz, double z) {
	point v = b - a;
//	if (bz - az == 0) {
//		cerr << "asd\n";
//		exit(0);
//	}
	double t = (z - az) / (bz - az);
	return a + v * t;
}


int main()
{                           		
//	freopen(fname"in", "r", stdin);
//	freopen(fname"out", "w", stdout);

	cin >> N >> zmin >> zmax;
	for (int i = 0, x, y, z; i < N; i++) {
		cin >> x >> y >> z;
		p[mag + z].pb(point(x, y));
	}

	zmin += mag, zmax += mag;
	for (int Z = zmin; Z <= zmax; Z++) {
		n = 0;
		forit(v, p[Z]) a[n++] = *v;
//		cerr << n << '\n';
		for (int z1 = 0; z1 < Z; z1++) 
			for (int z2 = Z + 1; z2 <= 202; z2++) 
				forit(A, p[z1]) forit(B, p[z2]) {
					a[n++] = inter(*A, *B, z1, z2, Z);
				}
		printf("%.8f\n", solve());
		
	}
	

	return 0;
}







