#include <cstdio>
#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <map>
#include <cstring>
#include <string>
#include <set>
#include <iomanip>
using namespace std;
typedef long long LL;
typedef pair<int,int> PII;
typedef vector<int> VI;
#define fname ""
#define pb push_back
#define F first
#define S second
#define mp make_pair
#define forit(it, s) for(__typeof(s.begin()) it = s.begin(); it != s.end(); it++)
#define all(s) s.begin(),s.end()
#define sqr(x) (x)*(x)
const int maxn = (int)1e6;
const int inf = (1 << 30) - 1;
const double badP = 12345676543.0;
const double eps = 1e-9;

struct point {
	double x, y;
	point () : x(0), y(0) {}
	point (double x, double y) : x(x), y(y) {}
	double mod2() {return x * x + y * y;}
	double mod() {return sqrt(mod2());}
	double ang() {return atan2(y, x);}
	double dist(point p) {return sqrt(sqr(x - p.x) + sqr(y - p.y));}
	point const operator + (const point &p) const {
		return point(x + p.x, y + p.y);
	}
	point const operator - (const point &p) const {
		return point(x - p.x, y - p.y);
	}
	point const operator * (double k) const {
		return point(x * k, y * k);
	}
	point const operator / (double k) const {
		return point(x / k, y / k);
	}
	double const operator * (const point &p) const {
		return x * p.y - y * p.x;
	}
	double const operator % (const point &p) const {
		return x * p.x + y * p.y;
	}
	void const operator *= (double k)  {
		x *= k, y *= k;
	}
	void const operator /= (double k) {
		x /= k, y /= k;
	}
	void rotat(double alpha) {
		double M = mod(), beta = ang();
		alpha += beta;
		x = M * cos(alpha);
		y = M * sin(alpha);
	}
};

double det(double a, double b, double c, double d) {
	return a * d - b * c;
}

struct line {
	double A, B, C;
	line() : A(0), B(0), C(0) {}
	line(double A, double B, double C) : A(A), B(B), C(C) {}
	line(point p1, point p2) {
		A = p2.y - p1.y;
		B = p1.x - p2.x;
		C = -A * p1.x - B * p1.y;
	}
	point intersect(line l) {
		double D = det(A, B, l.A, l.B);
		if (D == 0) return point(badP, badP);
		return point(-det(C, B, l.C, l.B) / D, -det(A, C, l.A, l.C) / D);
	}
	double pointDist(point p) {
		return (A * p.x + B * p.y + C) / sqrt(A * A + B * B);
	}
};



int main()
{
	

	int n;
	cin >> n;
	cout << n - (n + 1) / 2;

	return 0;
}







