#include <cstdio>
#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <map>
#include <cstring>
#include <string>
#include <set>
#include <iomanip>
using namespace std;
typedef long long LL;
typedef pair<int,int> PII;
typedef vector<int> VI;
#define fname ""
#define pb push_back
#define F first
#define S second
#define mp make_pair
#define forit(it, s) for(__typeof(s.begin()) it = s.begin(); it != s.end(); it++)
#define all(s) s.begin(),s.end()
#define sqr(x) (x)*(x)
const int inf = (1 << 30) - 1;
const double badP = 12345676543.0;
const double eps = 1e-4;
const double EPS = 1e-9;
const int maxn = (int)1e6;


/*        c
         /|
        / |
______a/__|b


*/

struct point {
	double x, y;
};

struct line {
	point a, b;
};

struct triangle {
	point a, b, c;
	double area;
};

double vect(point p1, point p2, point p3) {
	return (p2.x - p1.x) * (p3.y - p1.y) - (p3.x - p1.x) * (p2.y - p1.y);
}

double dist(point p1, point p2) {
	return sqrt(sqr(p1.x - p2.x) + sqr(p1.y - p2.y));
}

triangle tr[maxn];
int sz;

void add(point p1, point p2, point p3) {
	triangle t;
	t.a = p1;
	t.b = p2;
	t.c = p3;
	t.area = dist(p1, p2) * dist(p2, p3) / 2.0;

	tr[sz++] = t;

	return;
}

void calc(point a, point b, point c, point f) {
	if (dist(a, b) * dist(b, c) / 2.0 < eps) {
		add(a, b, c);
		return;
	}
	point m;
	m.x = (a.x + c.x) / 2.0;
	m.y = (a.y + c.y) / 2.0;
	if (abs(vect(b, m, f)) < EPS) {
		add(b, m, a);
		add(c, m, b);
		return;
	}     
	if (vect(b, m, f) < 0) {
		add(b, m, a);
		calc(c, m, b, f);
	} else {
		add(c, m, b);
		calc(b, m, a, f);
	}
	return;
}

bool isEqual(double A, double B) {
	if (abs(A - B) < EPS)
		return true;
	return false;
}

bool intersec_Point(point p, line l) {
	if (isEqual(dist(p, l.a) + dist(p, l.b), dist(l.a, l.b)))
		return true;
	return false;	
}

bool check(line l1, line l2) {
	if (vect(l1.a, l1.b, l2.a) * vect(l1.a, l1.b, l2.b) <= EPS)
		return true;
	return false;
}

bool intersec_line(line l1, line l2) {
	if (check(l1, l2) && check(l2, l1))
		return true;
	return false;
}

bool inter[3];

bool intersec_Triangle(triangle t, line l) {
	int cnt = 0;
	for (int i = 0; i < 3; ++i)
		inter[i] = false;
	if (intersec_Point(t.a, l))
		inter[0] = true, ++cnt;
	if (intersec_Point(t.b, l))
		inter[1] = true, ++cnt;
	if (intersec_Point(t.c, l))
		inter[2] = true, ++cnt;

	line my_line;
	if (!inter[0] && !inter[1]) {
		my_line.a = t.a;
		my_line.b = t.b;

		if (intersec_line(my_line, l))
			++cnt;
	}
	if (!inter[1] && !inter[2]) {
		my_line.a = t.b;
		my_line.b = t.c;

		if (intersec_line(my_line, l))
			++cnt;
	}
	if (!inter[2] && !inter[0]) {
		my_line.a = t.c;
		my_line.b = t.a;

		if (intersec_line(my_line, l))
			++cnt;
	}
	if (cnt == 2)
		return true;
	return false;
}

double solve(line l) {
	double res = 0;
	for (int i = 0; i < sz; ++i)
		if (intersec_Triangle(tr[i], l))
			res += tr[i].area;
	return res;
}

point a, b, c, p;
line l;

int main()
{
//	freopen(fname"in", "r", stdin);
//	freopen(fname"out", "w", stdout);

	scanf("%lf %lf", &p.x, &p.y);
	b.x = c.x = c.y = 10;
	l.a = a, l.b = p;
	calc(a, b, c, p);
	printf("%.7lf\n", solve(l));
	return 0;
}
