#include <cstdio>
#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <map>
#include <cstring>
#include <string>
#include <set>
#include <iomanip>
using namespace std;

const int maxn = (int)1e5;
const int maxsz = (int)2e4 + 10;
const int magic = (int)1e4 + 2;

struct point {
	int x, y, pos;
};

int sqr(int x) {
	return x * x;
}

int dist(point p1, point p2) {
	return sqr(p1.x - p2.x) + sqr(p1.y - p2.y);
}

int vect(point p1, point p2, point p3) {
	return (p2.x - p1.x) * (p3.y - p1.y) - (p3.x - p1.x) * (p2.y - p1.y);
}

point root;

bool cmp(point p1, point p2) {
	if (vect(root, p1, p2) > 0 || (!vect(root, p1, p2) && dist(root, p1) < dist(root, p2)))
		return true;
	return false;
}

point local[maxn];
int cnt[maxsz], head[maxsz];

void sort_(point *s, point *f) {
	for (int i = 0; i < maxsz; ++i)
		cnt[i] = 0;
	head[0] = 0;
	for (point *it = s; it != f; ++it)
		cnt[it -> y]++;
	int *it1 = head, *it2 = cnt;
	for (int i = 1; i < maxsz; ++i) {
		head[i] = *it1 + *it2;
		++it1, ++it2;
	}
	for (point *it = s; it != f; ++it)
		local[head[it -> y]++] = *it;
	int mal = 0;
	for (point *it = s; it != f; ++it, ++mal)
		*it = local[mal];

	for (int i = 0; i < maxsz; ++i)
		cnt[i] = 0;
	head[0] = 0;
	for (point *it = s; it != f; ++it)
		cnt[it -> x]++;
	it1 = head, it2 = cnt;
	for (int i = 1; i < maxsz; ++i) {
		head[i] = *it1 + *it2;
		++it1, ++it2;
	}
	for (point *it = s; it != f; ++it)
		local[head[it -> x]++] = *it;
	mal = 0;
	for (point *it = s; it != f; ++it, ++mal)
		*it = local[mal];

	return;
}

int n, N, clr, res[maxn];
point a[maxn];

vector <int> hull;
int st[maxn], h, w[maxn], nn, ok;

void build() {
	h = 0;
	for (int i = 0; i < n; i++) {
		while (h >= 1 && vect(a[st[h-2]], a[st[h-1]], a[i]) < 0)  h--;
		st[h++] = i;
	}
	if (ok)
		for (int i = 0; i < h; i++) hull.push_back(n - st[i] - 1);
	else
		for (int i = 0; i < h; i++) hull.push_back(st[i]);
}

void Graham() {
	hull.clear();
	ok = false;
	build();
	reverse(a, a + n);
	ok = true;
	build();
	reverse(a, a + n);
	for(int i = 0; i < (int)hull.size(); i++) {	
		w[hull[i]] = clr;
		res[a[hull[i]].pos] = clr;
	}
	nn = 0;
	for (int i = 0; i < n; i++) {
		if (w[i] != clr) a[nn++] = a[i];
	}
	n = nn;
}

int main()
{
//	freopen("in", "r", stdin);
//	freopen("out", "w", stdout);

	scanf("%d", &n);
	for (int i = 0; i < n; ++i) {
		scanf("%d%d", &a[i].x, &a[i].y);
		a[i].x += magic;
		a[i].y += magic;
		a[i].pos = i;
	}
 	N = n;
	sort_(a, a + n);

	while (n) {
		++clr;
		if (n <= 3) {
			for (int i = 0; i < n; ++i)
				res[a[i].pos] = clr;
			break;
		}
		Graham();
	}

	for (int i = 0; i < N; ++i)
		printf("%d\n", res[i]);
	
	return 0;
}
