#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef double ld;


#define sz(x) ((int) (x).size())
#define pb push_back
#define mp make_pair
#define fi first
#define se second

#define NAME "e"

ld eps = 1e-10;

struct pt
{
	ld x, y, z;
	
	pt(ld nx = 0, ld ny = 0, ld nz = 0): x(nx), y(ny), z(nz) {}
	
	ld operator*(const pt &a) const
	{
		return x * a.x + y * a.y + z * a.z;
	}
	
	pt operator%(const pt &p) const
	{
		return pt(y * p.z - z * p.y, 
				  z * p.x - x * p.z,
				  x * p.y - y * p.x);
	}
	
	pt operator - (const pt &p) const
	{
		return pt(x - p.x, y - p.y, z - p.z);
	}
	
	pt operator + (const pt &p) const
	{
		return pt(x + p.x, y + p.y, z + p.z);
	}
	
	pt operator / (const ld k) const
	{
		return pt(x / k, y / k, z / k);
	}
	
	pt operator * (const ld k) const
	{
		return pt(k * x, k * y, k * z);
	}
	
	ld operator ~() const
	{
		return sqrt((*this) * (*this));
	}
	
	ld sqlen() const
	{
		return *this * *this;
	}
};

pt byang(ld phi, ld lambda)
{
	return pt(cos(lambda) * cos(phi), sin(lambda) * cos(phi), sin(phi));
}

ld dist(pt a, pt b)
{
	return - (a * b);
}

const int M = 30;
const int L = 21;
const int P = 18;
const int ITER = 60;
const ld INF = 1e9;
int n;
pt c[M];

ld fun(ld p, ld l)
{
	ld ans = INF;
	pt k = byang(p, l);
	for (int i = 0; i < n; ++i)
		ans = min(ans, dist(c[i], k));
	return ans;
}

ld getans(ld p, ld ll, ld rr)
{
	for (int i = 0; i < ITER; ++i)
	{
		ld m1 = (2 * ll + rr) / 3;
		ld m2 = (ll + 2 * rr) / 3;
		if (fun(p, m1) > fun(p, m2))
			rr = m2;
		else
			ll = m1;
	}
	return fun(p, ll);
}

ld getans(ld pl, ld pr, ld ll, ld lr)
{
	for (int i = 0; i < ITER; ++i)
	{
		ld m1 = (2 * pl + pr) / 3;
		ld m2 = (pl + 2 * pr) / 3;
		if (getans(m1, ll, lr) > getans(m2, ll, lr))
			pr = m2;
		else
			pl = m1;
	}
	return getans(pl, ll, lr);
}

ld pi = acosl(-1.0);

ld normang(ld x)
{
	return x / 180 * pi;
}

void kill()
{
	cin >> n;
	for (int i = 0; i < n; ++i)
	{
		ld phi, lambda;
		cin >> phi >> lambda;
		phi = normang(phi);
		lambda = normang(lambda);
		c[i] = byang(phi, lambda);
	}
	
	ld ans = 0;
	for (int i = 0; i < P; ++i)
		for (int j = 0; j < L; ++j)
			ans = max(ans, getans(-pi / 2 + pi / P * i, -pi / 2 + pi / P * (i + 1),
									-pi + 2 * pi / L * j, -pi + 2 * pi / L * (j + 1)));
									
	cout << acos(-ans) << "\n";
}

int main()
{
	cout.precision(10);
	cout << fixed;
	#ifdef LOCAL
	assert(freopen(NAME ".in", "r", stdin));
	#endif // LOCAL
	kill();
	#ifdef LOCAL
	cerr << "Time: " << double(clock()) / CLOCKS_PER_SEC << "\n";
	#endif // LOCAL
	return 0;
}
