#include <iostream>
#include <cstdio>
#include <cmath>
#include <vector>

using namespace std;

const double EPS = 1e-9;

#define sqr(x) ((x) * (x))

bool doubleEqul(double a, double b) {
    return fabs(a - b) < EPS;
}
bool doubleLess(double a, double b) {
    return a < b && !doubleEqul(a, b);
}
bool doubleLessOrEqul(double a, double b) {
    return a < b || doubleEqul(a, b);
}

class point{
public:
    int x, y, z;
    point() {}
    point(int _x, int _y, int _z) {
        x = _x;
        y = _y;
        z = _z;
    }
    point operator+(const point & p) const {
        return point(x + p.x, y + p.y, z + p.y);
    }
    point operator-(const point & p) const {
        return point(x - p.x, y - p.y, z - p.z);
    }
    point operator*(const point & p) const {
        return point(y * p.z - z * p.y, z * p.x - x * p.z, x * p.y - y * p.x);
    }
    double operator%(const point & p) const {
        return x * p.x + y * p.y + z * p.z;
    }
    void scan() {
        scanf("%d %d %d", &x, &y, &z);
    }
    double distTo(point A) {
        return sqrt(sqr(A.x - this->x) + sqr(A.y - this->y) + sqr(A.z - this->z));
    }
    double length() {
        return sqrt(sqr(this->x) + sqr(this->y) + sqr(this->z));
    }
    double distTo(point A, point B) {
        double d = A.distTo(B);
        double s = ((*this - A) * (*this - B)).length();
        return s / d;
    }
    double distTo(const point & A, const point & B, const point & C) {
        cerr << "@\n";
        cerr << this->x << " " << this->y << " " << this->z << endl;
        cerr << A.x << " " << A.y << " " << A.z << endl;
        cerr << B.x << " " << B.y << " " << B.z << endl;
        cerr << C.x << " " << C.y << " " << C.z << endl;

        double V = (A - *this) * (B - *this) % (C - *this) / 3;
        double s = ((*this - A) * (*this - B)).length();
        cerr << V << " " << s << endl;
        return abs(V / s);
    }
};

vector<point> a(5);

/*double min(double a, double b) {
    if (doubleLess(a, b))
        return a;
    else return b;
}*/

int main()
{
    int m, h, H;
    scanf("%d %d %d", &m, &h, &H);

    for (int i = 0; i < 5; ++i) {
        cin >> a[i].x >> a[i].y;
        a[i].z = 0;
    }
    a[0].z = h;
    a[4].z = H;

    if (h > m) {
        cout << "NO\n";
        return 0;
    }

    double min_d = 1e9;
    for (int i = 1; i < 5; ++i) {
        min_d = min(min_d, a[0].distTo(a[i]));
    }

    cerr << "HERE" << min_d << " " << min_d + h << endl;

    for (int i = 1; i < 5; ++i)
        for (int j = i + 1; j < 5; ++j)
            min_d = min(min_d, a[0].distTo(a[i], a[j]));

    cerr << "HERE" << min_d << " " << min_d + h << endl;

    for (int i = 1; i < 5; ++i)
        for (int j = i + 1; j < 5; ++j)
            for (int k = j + 1; k < 5; ++k)
                min_d = min(min_d, a[0].distTo(a[i], a[j], a[k]));

    cerr << "HERE" << min_d << " " << min_d + h << endl;

//    cout << (min_d + h <= m ? "YES" : "NO") << endl;
    cout << (doubleLessOrEqul(min_d + h, m)? "YES" : "NO") << endl;
    return 0;
}
