#include <iostream>
#include <vector>
#include <cmath>

using namespace std;
//
//struct Plain {
//	Point a, b, c;
//	Plain(Point& a, Point& b, Point& c)
//	 : a(a), b(b), c(c) 
//	{}
//};
class Vector {
public:
	double x, y, z;
	Vector(double x1, double x2, double y1, double y2, double z1, double z2) 
	 : x(x2 - x1), y(y2 - y1), z(z2 - z1)
	{}

	Vector(double x, double y, double z) 
	 : x(x), y(y), z(z)
	{}

	double operator%(Vector& v) {
		return v.x * x + v.y * y + v.z * z;
	}

	Vector operator*(Vector& v) {
	
		return Vector(y * v.z - v.y * z,
			          v.x * z - x * v.z,
					  x * v.y - v.x *  y);
	}

	double len() {
		return sqrt(x * x + y * y + z * z);
	}
};

class Point;
Vector make_vector(Point& a, Point& b);

class Point {
public:
	double x, y, z;
	
	double dist(Point& a, Point& b, Point& c) {
		Vector AB = make_vector(a, b),
			   BC = make_vector(b, c),
			   CD = make_vector(c, *this);
		return fabs((AB * BC) % CD / (AB * BC).len());
	}
};

Vector make_vector(Point& a, Point& b) {
	return Vector(a.x, b.x, a.y, b.y, a.z, b.z);
}

int main()
{
	double m, h, H;
	cin >> m >> h >> H;
	Point v[5];
	for (int i = 0; i < 5; ++i) {
		double x, y;
		cin >> x >> y;
		v[i].x = x;
		v[i].y = y;
		v[i].z = 0;
	}
	m -= h;
	v[0].z = h;
	v[4].z = H;

	double d[4] = {v[0].dist(v[1], v[2], v[3]),
				   v[0].dist(v[1], v[2], v[4]),
				   v[0].dist(v[1], v[3], v[4]),
				   v[0].dist(v[2], v[3], v[4]),
				  };

	const double eps = 1e-9;
	double mn = d[0];
	for (int i = 0; i < 4; ++i) {
		if (mn - d[i] > eps) {
			mn = d[i];
		}
	}
	if (m - mn < -eps)
		cout << "NO";
	else
		cout << "YES";
	//cin >> m;
	return 0;
 }