#include <cstdio>
#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <cmath>
#include <cassert>
#include <memory.h>
#include <queue>
#include <deque>
#include <stack>
#include <list>
#include <map>
#include <set>
#include <functional>
#include <cstring>
#include <ctime>

using namespace std;

#define all(a) a.begin(), a.end()
#define mp make_pair

typedef long long li;
typedef long double ld;
typedef pair<int, int> pi;
typedef vector<int> vi;

#define FILENAME ""

void solve();
int main() {
#ifdef YA
	string s = FILENAME;
	//assert(!s.empty());
	clock_t start = clock();
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else
	//freopen(FILENAME ".in", "r", stdin);
	//freopen(FILENAME ".out", "w", stdout);
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#endif
	cout.sync_with_stdio(0);
	cin.tie(0);
	cout.precision(15);
	cout << fixed;

	int t = 1;
	//cin >> t;
	while(t--) {
		solve();
	}
#ifdef YA
	cout << "\n\n" << (clock() - start) / 1.0 / CLOCKS_PER_SEC << "\n\n";
#endif
	return 0;
}


//#define int li

ld eps = 1e-9;

struct Point {
	ld x, y;

	Point() {
	}

	Point(ld x, ld y):x(x), y(y) {
	}

	Point operator - (const Point& p)const {
		return Point(x - p.x, y - p.y);
	}

	bool operator < (const Point& p) const{
		return x < p.x || x == p.x && y < p.y;
	}

	bool operator == (const Point& p) const{
		return fabs(x - p.x) < eps && fabs(y - p.y) < eps;
	}

	ld operator *(const Point& p) const{
		return x * p.y - y * p.x;
	}

	ld operator %(const Point& p) const{
		return x * p.x + y * p.y;
	}

	Point operator + (const Point& p) const {
		return Point(x + p.x, y + p.y);
	}

	Point operator / (ld z) const {
		return Point(x / z, y / z);
	}

	Point operator * (ld z) const {
		return Point(x * z, y * z);
	}

	ld dist() const {
		return sqrt(x * x + y * y);
	}

	void scan() {
		cin >> x >> y;
	}
};

int n;
vector<Point> points;

struct line {
	ld a, b, c;
	line(const Point& p1, const Point& p2) {
		a = p1.y - p2.y;
		b = p2.x - p1.x;
		c = p1 * p2;
		ld d = sqrt(a * a + b * b);
		a /= d;
		b /= d;
		c /= d;
	}

	ld distFrom(const Point& p) {
		return -(a * p.x + b * p.y + c);
	}

};

vector<line> lines;


ld valu(ld x, ld y) {
	ld res = 1e18;
	for (int i = 0; i < lines.size(); ++i) {
		ld cur = lines[i].distFrom(Point(x, y));
		res = min(res, cur);
	}
	return res;
}

ld good(ld x) {
	ld lx = -1e6, rx = 1e6;

	while (rx - lx > eps) {

		ld mx1 = (2 * lx + rx) / 3;
		ld mx2 = (lx + 2 * rx) / 3;

		if (valu(x, mx1) > valu(x, mx2))
			rx = mx2;
		else
			lx = mx1;
	}

	return valu(x, lx);
}

bool enough(int k) {
	lines.clear();
	for (int i = 0; i < n; ++i) {
		int j = (i + k + 1) % n;
		lines.push_back(line(points[i], points[j]));
	}

	ld lx = -1e6, rx = 1e6;

	while (rx - lx > eps) {

		ld mx1 = (2 * lx + rx) / 3;
		ld mx2 = (lx + 2 * rx) / 3;

		if (good(mx1) > good(mx2))
			rx = mx2;
		else
			lx = mx1;
	}

	return good(lx) > eps;
}

void solve() {
	cin >> n;
	points.resize(n);
	for (int i = 0; i < n; ++i)
		points[i].scan();
	reverse(all(points));

	int l = 0, r = (n-2);//(n - 1) / 2;

	while(l + 1 < r) {
		int m = (l + r) / 2;
		if (enough(m))
			r = m;
		else
			l = m;
	}

	cout << r;
}