#include <cstdio>
#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <cmath>
#include <cassert>
#include <memory.h>
#include <queue>
#include <deque>
#include <stack>
#include <list>
#include <map>
#include <set>
#include <functional>
#include <cstring>
#include <ctime>

using namespace std;

#define all(a) a.begin(), a.end()
#define mp make_pair

typedef long long li;
typedef long double ld;
typedef pair<int, int> pi;
typedef vector<int> vi;

#define FILENAME ""

void solve();
int main() {
#ifdef YA
	string s = FILENAME;
	//assert(!s.empty());
	clock_t start = clock();
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else
	//freopen(FILENAME ".in", "r", stdin);
	//freopen(FILENAME ".out", "w", stdout);
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#endif
	cout.sync_with_stdio(0);
	cin.tie(0);
	cout.precision(15);
	cout << fixed;

	int t = 1;
	//cin >> t;
	while(t--) {
		solve();
	}
#ifdef YA
	cout << "\n\n" << (clock() - start) / 1.0 / CLOCKS_PER_SEC << "\n\n";
#endif
	return 0;
}


//#define int li


struct Point {
	int x, y, z;

	Point() {
	}

	Point(int x, int y, int z):x(x), y(y), z(z) {
	}

	Point operator - (const Point& p)const {
		return Point(x - p.x, y - p.y, z - p.z);
	}

	bool operator < (const Point& p) const{
		return x < p.x || x == p.x && mp(y, z) < mp(p.y, p.z);
	}

	Point operator * (const Point& p) const{
		return Point(y * p.z - z * p.y, z * p.x - x * p.z, x * p.y - y * p.x);
	}

	int operator % (const Point& p) const {
		return x * p.x + y * p.y + z * p.z;
	}

	ld dist() const {
		return sqrt(x * 1.0 * x + y * 1.0 * y);
	}

};



void solve() {
	int m, h, H;

	cin >> m >> h >> H;

	Point in;
	cin >> in.x >> in.y;
	in.z = h;

	Point points[4];
	for (int i = 0; i < 4; ++i) {
		cin >> points[i].x >> points[i].y;
		points[i].z = 0;
		if (i == 3)
			points[i].z = H;
	}

	vector<int> p(4);
	for (int i = 0; i < 4; ++i)
		p[i] = i;

	for (int ex = 0; ex < 4; ++ex) {
		vector<Point> way;
		vector<Point> face;

		for (int j = 0; j < 4; ++j)
			if (j != ex) {
				way.push_back(points[j] - in);
				face.push_back(points[j]);
			}

		int V = abs((way[0] * way[1]) % way[2]);

		int S = int(((face[2] - face[0]) * (face[1] - face[0])).dist() + 1e-9);

		if (h * S + V <= m * S) {
			cout << "YES\n";
			return;
		}

	}

	cout << "NO\n";

}