#include <cstdio>
#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <cmath>
#include <cassert>
#include <memory.h>
#include <queue>
#include <deque>
#include <stack>
#include <list>
#include <map>
#include <set>
#include <functional>
#include <cstring>
#include <ctime>

using namespace std;

#define all(a) a.begin(), a.end()
#define mp make_pair

typedef long long li;
typedef long double ld;
typedef pair<int, int> pi;
typedef vector<int> vi;

#define FILENAME ""

void solve();
int main() {
#ifdef YA
	string s = FILENAME;
	//assert(!s.empty());
	clock_t start = clock();
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else
	//freopen(FILENAME ".in", "r", stdin);
	//freopen(FILENAME ".out", "w", stdout);
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#endif
	cout.sync_with_stdio(0);
	cin.tie(0);
	cout.precision(15);
	cout << fixed;

	int t = 1;
	//cin >> t;
	while(t--) {
		solve();
	}
#ifdef YA
	cout << "\n\n" << (clock() - start) / 1.0 / CLOCKS_PER_SEC << "\n\n";
#endif
	return 0;
}


//#define int li

ld eps = 1e-9;

struct Point {
	ld x, y;

	Point() {
	}

	Point(ld x, ld y):x(x), y(y) {
	}

	Point operator - (const Point& p)const {
		return Point(x - p.x, y - p.y);
	}

	bool operator < (const Point& p) const{
		return x < p.x || x == p.x && y < p.y;
	}

	bool operator == (const Point& p) const{
		return fabs(x - p.x) < eps && fabs(y - p.y) < eps;
	}

	ld operator *(const Point& p) const{
		return x * p.y - y * p.x;
	}

	Point operator + (const Point& p) const {
		return Point(x + p.x, y + p.y);
	}

	Point operator / (ld z) const {
		return Point(x / z, y / z);
	}

	Point operator * (ld z) const {
		return Point(x * z, y * z);
	}

	ld dist() const {
		return sqrt(x * x + y * y);
	}
};

bool intersection(const Point& a, const Point& aa, const Point& b, const Point& bb, Point& inter) {
	Point vecA = aa - a;
	Point vecB = bb - b;

	ld det = vecA * vecB;

	if (fabs(det) < 1e-9)
		return 0;

	ld detA = (b - a) * vecB;
	ld detB = vecA * (b - a);

	ld t = detA / det;

	ld u = -detB / det;

	if (t < -eps || t > 1 + eps || u < -eps || u > 1 + eps)
		return 0;

	inter = a + (vecA * t);

	return 1;
}

void solve() {
	Point A (0, 0), B(10, 0), C(10, 10);
	Point F;
	cin >> F.x >> F.y;
	Point S = A;
	double ans = 0;
	for(int i = 0; i < 100000; ++i) {
		if(F == S)
			break;
		Point D = (A + C) / 2;
		Point inter;
		if(intersection(S, F, B, D, inter)) {
			ans += (D - B).dist() * (C - A).dist() / 2;
			S = inter;
		}
		else {
		}
		if((F - C).dist() > (A - F).dist()) {
			C = A;
		}
		A = B;
		B = D;
	}

	cout << ans /2;
}