#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <iostream>
#include <string>
#include <vector>
#include <memory.h>
#include <algorithm>
#include <map>
#include <set>
#include <queue>
#include <cassert>

using namespace std;

#define fore(i, b, e) for (int i = (int)b; i <= (int)e; i++)
#define forn(i, n) for (int i = 0; i < (int)n; i++)
#define fi first
#define se second
#define pii pair <int, int>
#define mp make_pair
#define i64 long long
#define li long long
#define vi vector <int>

#define EPS (1e-7)

inline double min(double a, double b, double c, double d) {
	return min(a, min(b, min(c, d)));
}

inline double sqr(double a) {
	return a * a;
}

struct point {
	double x, y, z;
	point(){}
	point(double _a, double _b, double _c) {
		x = _a, y = _b, z = _c;
	}

	void read() {
		cin >> x >> y >> z;
	}
};

typedef double matrix[3][3];

/*
struct matr {
	matr() { }
	matr(double a11, double a12, double a13, double a21, double a22, double a23, double a31, double a32, double a33) {
		a[1][1] = a11;
		a[1][2] = a12;
		a[1][3] = a13;
		a[2][1] = a21;
		a[2][2] = a22;
		a[2][3] = a23;
		a[3][1] = a31;
		a[3][2] = a32;
		a[3][3] = a33;
	}
	double a[4][4];
};*/

double det(matrix a) {
	return a[0][0] * (a[1][1] * a[2][2] - a[1][2] * a[2][1])
		- a[0][1] * (a[1][0] * a[2][2] - a[1][2] * a[2][0]) + a[0][2] * (a[1][0] * a[2][1] - a[1][1] * a[2][0]);
}

void replace(int i, matrix a, double c[3], matrix res) {
	for (int i1 = 0; i1 < 3; i1++) {
		for (int i2 = 0; i2 < 3; i2++) {
			if (i2 == i) res[i1][i2] = c[i1];
			else res[i1][i2] = a[i1][i2];
		}
	}
}

bool solve(matrix a, double c[3], double & x, double & y, double & z) {
	matrix m1, m2, m3;
	if (fabs(det(a)) < EPS) return false;
	replace(0, a, c, m1);
	replace(1, a, c, m2);
	replace(2, a, c, m3);
	x  = -det(m1) / det(a);
	y = -det(m2) / det(a);
	z = -det(m3) / det(a);
	for (int i= 0; i < 3; i++) {
		double r = c[i] + a[i][0] * x + a[i][1] * y + a[i][2] * z;
		assert(fabs(r) < EPS);
	}
	return true;
}

struct plane {
	plane() {}
	plane(double _a, double _b, double _c, double _d) {
		a = _a, b = _b, c = _c, d = _d;
	}
	plane(point _a, point _b, point _c) {
		
		plane res;
		// a == 1
		{
			a = 1;
			matrix m = { {_a.y, _a.z, 1},
						 {_b.y, _b.z, 1},
						 {_c.y, _c.z, 1}};
			double v[3] = {_a.x, _b.x, _c.x};  
			if (solve(m, v, b, c, d))
					return;
		}
		// b == 1
		{
			b = 1;
			matrix m = { {_a.x, _a.z, 1},
						 {_b.x, _b.z, 1},
						 {_c.x, _c.z, 1}};
			double v[3] = {_a.y, _b.y, _c.y};  
			if (solve(m, v, a, c, d))
					return;
		}
		// c == 1
		{
			c = 1;
			matrix m = { {_a.x, _a.y, 1},
						 {_b.x, _b.y, 1},
						 {_c.x, _c.y, 1}};
			double v[3] = {_a.z, _b.z, _c.z};  
			if (solve(m, v, a, b, d))
					return;
		}
	}
	double a, b, c, d;
};

inline double dist(point a, plane b) {
	return fabs((b.a * a.x + b.b * a.y + b.c * a.z + b.d) / sqrt(sqr(b.a) + sqr(b.b) + sqr(b.c)));
}

double m;
point a, b, c, d, x;

int main()
{


	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);

	cin >> m >> x.z >> d.z;
	cin >> x.x >> x.y;
	cin >> a.x >> a.y;
	cin >> b.x >> b.y;
	cin >> c.x >> c.y;
	cin >> d.x >> d.y;
	a.z = b.z = d.z = 0;

	//cerr << det(matr(1, 0, 0, 0, 1, 0, 0, 0, 1)) << endl;
	point _a(3, 2, 9);
	point _b(1, 2, 2);
	point _c(5, 4, 2);
	plane q(_b, _c, _a);
	//cerr.setf(ios::fixed);
	//cerr.precision(3);
	//cerr << q.a << ' ' << q.b << ' ' << q.c << ' ' << q.d << endl;
	//cerr << dist(_a, q) << " " << dist(_b, q) << " " << dist(_c, q) << endl;

	double res = x.z;
	double r = 0;
	res += min(dist(x, plane(a, b, c)), dist(x, plane(a, b, d)), dist(x, plane(b, c, d)), dist(x, plane(a, c, d)));
	//cerr << res-x.z << endl;
	if (m - res > -EPS) 
		cout << "YES" << endl;
	else
		cout << "NO" << endl;
}