#include <iostream>
#include <cstdio>
#include <set>
#include <map>
#include <queue>
#include <vector>
#include <fstream>
#include <sstream>
#include <algorithm>
#include <cassert>
#include <ctime>
#include <cmath>
#include <string>

#define fore(i, a, b) for(int i = (int)(a); i <= (int)(b); ++i)
#define forn(i, n) for (int i = 0; i < (int)(n); ++i)
#define for1(i, n) for (int i = 1; i <= (int)(n); ++i)
#define ford(i, n) for (int i = (int)(n) - 1; i >= 0; --i)
#define all(x) (x).begin(), (x).end()
#define mp make_pair
#define pb push_back
#define fi first
#define se second

using namespace std;

typedef long double ld;
typedef long long i64;
typedef vector<int> vi;
typedef vector<i64> vi64;
typedef pair<int, int> pii;
typedef unsigned int u32;
typedef vector<pii> vpi;

const ld eps = 1e-8;
inline bool eq(ld x, ld y)
{
	return fabsl(x - y) < eps;
}
inline bool le(ld x, ld y)
{
	return y - x > eps;
}
inline bool gr(ld x, ld y)
{
	return x - y > eps;
}

struct Pt3 {
	ld x, y, z;
	Pt3() {}
	Pt3( ld x, ld y, ld z) :x(x), y(y), z(z) {}
	Pt3 operator - (const Pt3& o) const { return Pt3( x - o.x, y - o.y, z - o.z); }
	ld operator & (const Pt3& o) const { return x * o.x + y * o.y + z * o.z; }
	Pt3 operator * (const Pt3& o) const {
		return Pt3( y * o.z - z * o.y, z * o.x - x * o.z, x * o.y - y * o.x); 
	}
	ld len2() const { return x * x + y * y + z * z; }
	ld len() const { return sqrtl(len2()); }
	bool operator == (const Pt3& o) const { return eq(x, o.x) && eq(y, o.y) && eq(z, o.z); }
};


ld dist(const Pt3& p, const Pt3& a, const Pt3& b) {
	if( (a==b) ) return (p-a).len();
	if( ((a-b)&(p-b)) < 0 ) return (p-b).len();
	if( ((b-a)&(p-a)) < 0 ) return (p-a).len();
	return fabsl((p-a)&(b-a)) / (b-a).len();
}

ld dist(const Pt3& p, const Pt3& a, const Pt3& b, const Pt3& c) {
	Pt3 n = (b - a) * (c - a);
	ld v0 = ((a - p) * (b - p)) & n;
	ld v1 = ((b - p) * (c - p)) & n;
	ld v2 = ((c - p) * (a - p)) & n;
	if( (v0 > eps && v1 > eps && v2 > eps) || (v0 < -eps && v1 < -eps && v2 < -eps) ) {
		return fabsl(((a - p) * (b - p)) & (c - p)) / ((a - b)*(c - b)).len();
	}
	return min(min((p-a).len(), (p-b).len() ), (p-c).len());
}

int main() {
	cin.sync_with_stdio();
	cin.tie(0);
	cout.precision(12);
	cout << fixed;
	cerr.precision(12);
	cerr << fixed;
#ifdef HOME
	freopen("input.txt", "r", stdin);
#endif
	ld m, h, H;
	cin >> m >> h >> H;
	vector<Pt3> v(5);
	forn(i, 5) {
		cin >> v[i].x >> v[i].y;
	}
	v[0].z = h;
	v[4].z = H;
	bool YES = false;
	fore(i, 1, 4) {
		vector<Pt3> u;
		fore(j, 1, 4) if( j != i ) u.pb(v[j]);
		if( dist(v[0], u[0], u[1], u[2]) + h <= m - eps ) {
//			cerr << dist(v[0], u[0], u[1], u[2]) << '\n';
			YES = true;
		}
	}
	cout << (YES ? "YES" : "NO") << '\n'; 
	return 0;
}
