#include <iostream>
#include <cstdio>
#include <set>
#include <map>
#include <queue>
#include <vector>
#include <fstream>
#include <sstream>
#include <algorithm>
#include <cassert>
#include <ctime>
#include <cmath>
#include <string>

#define fore(i, a, b) for(int i = (int)(a); i <= (int)(b); ++i)
#define forn(i, n) for (int i = 0; i < (int)(n); ++i)
#define for1(i, n) for (int i = 1; i <= (int)(n); ++i)
#define ford(i, n) for (int i = (int)(n) - 1; i >= 0; --i)
#define all(x) (x).begin(), (x).end()
#define mp make_pair
#define pb push_back
#define fi first
#define se second

using namespace std;

typedef long double ld;
typedef long long i64;
typedef vector<int> vi;
typedef vector<i64> vi64;
typedef pair<int, int> pii;
typedef unsigned int u32;
typedef vector<pii> vpi;

const ld eps = 1e-8;
inline bool eq(ld x, ld y)
{
	return fabsl(x - y) < eps;
}
inline bool le(ld x, ld y)
{
	return y - x > eps;
}
inline bool gr(ld x, ld y)
{
	return x - y > eps;
}
inline bool ge(ld x, ld y)
{
	return x - y >= -eps;
}
struct Pt
{
	ld x, y;
	Pt() {}
	Pt(ld x, ld y): x(x),y(y){}
	Pt operator + (const Pt& p) const
	{
		return Pt(x + p.x, y + p.y);
	}
	Pt operator - (const Pt& p) const
	{
		return Pt(x - p.x, y - p.y);
	}
	Pt operator * (ld k) const 
	{
		return Pt(x * k, y * k);
	}
	ld operator * (const Pt& p) const
	{
		return x * p.y - y * p.x;
	}
	ld operator & (const Pt& p) const
	{
		return x * p.x + y * p.y;
	}
	Pt operator - ()
	{
		return Pt(-x, -y);
	}
	void print() const
	{
		cout << x << " " << y << endl;
	}
	void read()
	{
		cin >> x >> y;
	}
	Pt rotate(ld ang) const
	{
		return Pt(x*cos(ang)-y*sin(ang), x*sin(ang) + y*cos(ang));
	}
	bool operator < ( const Pt& o) const { return mp(x, y) < mp(o.x, o.y); }
};

bool isIn(Pt P, Pt A, Pt B, Pt C) {
	ld v0 = (A - P) * (B - P);
	ld v1 = (B - P) * (C - P);
	ld v2 = (C - P) * (A - P);
	if( v0 > eps && v1 > eps && v2 > eps ) return true; 
	if( v0 < -eps && v1 < -eps && v2 < -eps ) return true; 
	return false;
}

int sign(ld x) {
	return (x > eps) - (x < -eps);
}

bool checkIn(Pt a, Pt b, Pt p) {
	if( !eq((p - a) * (b - a),0) ) return false;
	return ge((p-a)&(b-a),0) && ge((p-b)&(a-b),0);
}

int isInter(Pt a, Pt b, Pt p, Pt q) {
	if( sign((p - a)*(b - a)) * sign((q - a)*(b - a)) > 0 ) return 0;
	if( sign((a - q)*(p - q)) * sign((b - q)*(p - q)) > 0 ) return 0;
	
	if( checkIn(a, b, p) || checkIn(a, b, q) || checkIn(p, q, a) || checkIn(p, q, b) )
		return 1;
	return 2;
}

ld solve(Pt P, Pt Q, Pt A, Pt B, Pt C) {
	if( !isIn(Q, A, B, C) ) {
		if( isInter(P, Q, A, B) + isInter(P, Q, B, C) + isInter(P, Q, C, A) < 3 ) {
//		if( !isInter(P, Q, A, B) && !isInter(P, Q, B, C) && !isInter(P, Q, C, A) ) {
			return 0;
		}
//		A.print();B.print();C.print();
//		cout << " add \n";
		return fabsl((A-B)*(C-A)) * 0.5;
	}
	ld r = 0;
	Pt M = (A+C) * 0.5;
	r += solve(P, Q, B, M, A);
	r += solve(P, Q, B, M, C);
	return r;
}

int main() {
	cin.sync_with_stdio();
	cin.tie(0);
	cout.precision(12);
	cout << fixed;
	cerr.precision(12);
	cerr << fixed;
#ifdef HOME
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	Pt a(0,0), b(10,0), c(10,10);
	Pt P(0,0), Q;
	cin >> Q.x >> Q.y;
	ld ans = solve(P, Q, a, b, c);
	cout << ans << '\n';
	return 0;
}
