#include <iostream>
#include <cstdio>
#include <set>
#include <map>
#include <queue>
#include <vector>
#include <fstream>
#include <sstream>
#include <algorithm>
#include <cassert>
#include <ctime>
#include <cmath>
#include <string>

#define forn(i, n) for (int i = 0; i < (int)(n); ++i)
#define for1(i, n) for (int i = 1; i <= (int)(n); ++i)
#define ford(i, n) for (int i = (int)(n) - 1; i >= 0; --i)
#define all(x) (x).begin(), (x).end()
#define mp make_pair
#define pb push_back
#define fi first
#define se second

using namespace std;

typedef long double ld;
typedef long long i64;
typedef vector<int> vi;
typedef vector<i64> vi64;
typedef pair<int, int> pii;
typedef unsigned int u32;
typedef vector<pii> vpi;

const int N = 100500;
const ld eps = 1e-10;
inline bool eq(ld x, ld y)
{
	return fabsl(x - y) < eps;
}
inline bool le(ld x, ld y)
{
	return y - x > eps;
}
inline bool gr(ld x, ld y)
{
	return x - y > eps;
}
struct Pt;
int compPt(const Pt& a, const Pt& b);

struct Pt
{
	ld x, y;
	Pt() {}
	Pt(ld x, ld y): x(x),y(y){}
	Pt operator + (const Pt& p) const
	{
		return Pt(x + p.x, y + p.y);
	}
	Pt operator - (const Pt& p) const
	{
		return Pt(x - p.x, y - p.y);
	}
	Pt operator * (ld k) const 
	{
		return Pt(x * k, y * k);
	}
	ld operator * (const Pt& p) const
	{
		return x * p.y - y * p.x;
	}
	ld operator ^ (const Pt& p) const
	{
		return x * p.x + y * p.y;
	}
	Pt operator - ()
	{
		return Pt(-x, -y);
	}
	void print() const
	{
	}
	void read()
	{
		int _x, _y;
		scanf("%d%d", &_x, &_y);
		x = _x;
		y = _y;
	}
	Pt rotate(ld ang) const
	{
		return Pt(x*cos(ang)-y*sin(ang), x*sin(ang) + y*cos(ang));
	}
	bool type() const
	{
		return y > eps || (eq(y, 0) && x > eps);
	}
};

int compPt(const Pt& a, const Pt& b)
{
	if (a.type() != b.type()){
		if (a.type()) return -1;
		else return 1;
	}
	if (a * b > eps) return -1;
	if (a * b < -eps) return 1;
	return 0;
}

ld getAng(const Pt& p, const Pt& q)
{
	return atan2(p*q,p^q);
}

struct Line
{
	ld A, B, C;
	Pt p;
	bool operator < (const Line& l) const
	{
		int t = compPt(p, l.p);
		if (!t)
		{
			return C > l.C;
		}
		return (t == -1);
	}
	Line() {}
	Line(ld _A, ld _B, ld _C)  {
		ld D = sqrtl(_A*_A+_B*_B);
		A = _A/D;
		B = _B/D;
		C = _C/D;
		p = Pt(A, B);
	}
	Line(const Pt& a, const Pt& b)
	{
		A = b.y - a.y;
		B = a.x - b.x;
		ld D = sqrtl(A*A+B*B);
		C = -a.x*A-a.y*B;
		p = Pt(A, B);
	}
};

bool check(Line l1, Line l2)
{
	return (l1.p * l2.p) < eps && (l1.p ^ l2.p) > 0.0;
}

int good(Line l1, Line l2)
{
	ld tmp = l1.p * l2.p;
	if (tmp > eps || (tmp > -eps && (l1.p^l2.p) > 0)) return 1;
	if (tmp < -eps) return -1;
	//if (l1.C > l2.C + eps) return -1;
	if (l1.C > -l2.C + eps) return -1;
	else return 0;
}

ld distLine(Line l, Pt p)
{
	return l.A * p.x + l.B * p.y + l.C;
}

bool intLine(Line l1, Line l2, Pt& p)
{
	ld d = l1.A * l2.B - l1.B * l2.A;
	if (eq(d,0)) return false;
	p.x = (l1.B*l2.C-l1.C*l2.B)/d;
	p.y = (l1.C*l2.A-l1.A*l2.C)/d;
	return true;
}

Pt p[N];
Line l[N];
ld solve(vector<Line>& a)
{
	int n = a.size();
	sort(all(a));
	forn (i, n)
	{
		int tmp = good(a[i], a[(i + 1) % n]);
		if (tmp <= 0) return tmp;
	}
	int last = 0, cnt = 0;
	forn (i, n)
	{
		if (i < n - 1 && check(a[i], a[i + 1])) continue;
		cnt++;
		while (last > 1 && distLine(a[i], p[last - 1]) < eps) last--;
		if (last == 1 && l[last - 1].p * a[i].p < eps) return 0;
		if (last > 0) intLine(l[last - 1], a[i], p[last]);
		l[last++] = a[i];
	}
	if (cnt <= 2) return -1;
	//cerr << a.size() << endl;
	int f = 0;
	for (;;)
	{
		bool fin = true;
		while (f < last - 3 && distLine(l[last - 1], p[f + 1]) < eps){f++;fin = 0;}
		while (f < last - 3 && distLine(l[f], p[last - 1]) < eps){last--;fin = 0;}
		if (fin) break;
	}
	intLine(l[f], l[last - 1], p[f]);
	ld ans = 0;
	int m = last - f;
	if (m <= 1) return -1;
	forn (i, m)
	{
		ans += p[f + i] * p[f + (i + 1) % m];
	}
	return fabs(ans/2.0);
}

int main() {
	cin.sync_with_stdio();
	cin.tie(0);
	cout.precision(12);
	cout << fixed;
	cerr.precision(12);
	cerr << fixed;

#ifdef HOME
#define TASK "d"
	freopen(TASK".in", "r", stdin);
	freopen(TASK".out", "w", stdout);
	freopen(TASK".err", "w", stderr);

#endif
	
	int n;
	scanf("%d", &n);
	vector<Line> l(n);
	forn (i, n) {
		int a, b, c;
		scanf("%d%d%d", &a, &b, &c);
		l[i] = Line(a, b, c);
	}
	ld r = solve(l);
	if (r < -eps) puts("-1");
	else cout << r << "\n";
	return 0;
}
