#include <iostream>
#include <cstdio>
#include <set>
#include <map>
#include <queue>
#include <vector>
#include <fstream>
#include <sstream>
#include <algorithm>
#include <cassert>
#include <ctime>
#include <cmath>
#include <string>

#define fore(i, a, b) for(int i = (int)(a); i <= (int)(b); ++i)
#define forn(i, n) for (int i = 0; i < (int)(n); ++i)
#define for1(i, n) for (int i = 1; i <= (int)(n); ++i)
#define ford(i, n) for (int i = (int)(n) - 1; i >= 0; --i)
#define all(x) (x).begin(), (x).end()
#define mp make_pair
#define pb push_back
#define fi first
#define se second

using namespace std;

typedef long double ld;
typedef long long i64;
typedef vector<int> vi;
typedef vector<i64> vi64;
typedef pair<int, int> pii;
typedef unsigned int u32;
typedef vector<pii> vpi;

const ld eps = 1e-8;
inline bool eq(ld x, ld y)
{
	return fabsl(x - y) < eps;
}
inline bool le(ld x, ld y)
{
	return y - x > eps;
}
inline bool gr(ld x, ld y)
{
	return x - y > eps;
}
struct Pt
{
	ld x, y;
	Pt() {}
	Pt(ld x, ld y): x(x),y(y){}
	Pt operator + (const Pt& p) const
	{
		return Pt(x + p.x, y + p.y);
	}
	Pt operator - (const Pt& p) const
	{
		return Pt(x - p.x, y - p.y);
	}
	Pt operator * (ld k) const 
	{
		return Pt(x * k, y * k);
	}
	ld operator * (const Pt& p) const
	{
		return x * p.y - y * p.x;
	}
	ld operator ^ (const Pt& p) const
	{
		return x * p.x + y * p.y;
	}
	Pt operator - ()
	{
		return Pt(-x, -y);
	}
	void print() const
	{
		cout << x << " " << y << endl;
	}
	void read()
	{
		cin >> x >> y;
	}
	Pt rotate(ld ang) const
	{
		return Pt(x*cos(ang)-y*sin(ang), x*sin(ang) + y*cos(ang));
	}
	bool operator < ( const Pt& o) const { return mp(x, y) < mp(o.x, o.y); }
};

const int N = 2 * 10000 + 10;
Pt a[N];
int pts[N];
int n;
int sup, sdown;
int up[N];
int down[N];
int ans[N];

struct cmp {
	bool operator()(int i, int j) {
		return a[i] < a[j];
	}
};

int main() {
	cin.sync_with_stdio();
	cin.tie(0);
	cout.precision(12);
	cout << fixed;
	cerr.precision(12);
	cerr << fixed;
#ifdef HOME
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
//	n = 20000;
	cin >> n;
	int n0 = n;
//	forn(i, n) a[i].x = i;
//	forn(i, n) a[i].y = i * i;
	forn(i, n) cin >> a[i].x >> a[i].y;
	forn(i, n) pts[i] = i;
	sort(pts, pts + n, cmp());
	int step = 0;
	while( n > 0 ) {
		++step;
		sup = sdown = 0;
		forn(i, n) {
			while( sup > 1 && (a[up[sup-1]] - a[up[sup-2]]) * (a[pts[i]] - a[up[sup-2]]) > 0 )
				--sup;
			up[sup++] = pts[i];
			while( sdown > 1 && (a[down[sdown-1]] - a[down[sdown-2]]) * (a[pts[i]] - a[down[sdown-2]]) < 0 )
				--sdown;
			down[sdown++] = pts[i];
		}
		forn(i, sup) ans[up[i]] = step;
		forn(i, sdown) ans[down[i]] = step;
		
		int nn = 0;
		forn(i, n) if( ans[pts[i]] == 0 )
			pts[nn++] = pts[i];
		n = nn;
	}
	forn(i, n0) cout << ans[i] << '\n';
	return 0;
}
