#include <bits/stdc++.h>

#define pb puah_back
#define mp make_pair
#define all(x) (x).begin(), (x).end()
#define x first
#define y second

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef int itn;
typedef pair<int, int> PII;

int nxt() {
    int n;
    scanf("%d", &n);
    return n;
}


const long double eps = 1e-8;

struct pt {
    long double x, y;
    pt() {}
    pt(const long double &x, const long double &y) : x(x), y(y) {}

    pt operator - (const pt &r) const {
        return pt(x - r.x, y - r.y);
    }

    pt operator + (const pt &r) const {
        return pt(x + r.x, y + r.y);
    }

    pt operator * (const double &r) const {
        return pt(x * r, y * r);
    }

    friend long double scal(const pt &l, const pt &r) {
        return l.x * r.x + l.y * r.y;
    }
    friend long double vect(const pt &l, const pt &r) {
        return l.x * r.y - l.y * r.x;
    }
    long double lenSQ() const {
        return fabsl(x * x + y * y);
    }

    bool operator < (const pt &r) const {
        if (fabsl(x - r.x) > eps) {
            return x < r.x;
        }
        return y < r.y;
    }

    bool operator == (const pt &r) const {
        return fabs(x - r.x) < eps && fabs(y - r.y) < eps;
    }
};

pt cmp_pt;
bool cmp(const pt &l, const pt &r) {
    pt L = l - cmp_pt;
    pt R = r - cmp_pt;
    long double ve = vect(L, R);
    if (fabsl(ve) < eps) {
        return L.lenSQ() < R.lenSQ();
    }
    return ve > 0;
}


long double square(const vector<pt> &a) {
    if (a.size() <= 2) {
        return 0;
    }
    int n = a.size();
    long double ans = 0;
    for (int i = 1; i + 1 < n; ++i) {
        ans += vect(a[i] - a[0], a[i + 1] - a[0]);
    }
    return fabs(ans) / 2.0;
}

vector<pt> convex(const vector<pt> &ttt) {
    vector<pt> a = ttt;
    sort(all(a));
    a.resize(unique(all(a)) - a.begin());
    if (a.size() <= 2) {
        return a;
    }

    cmp_pt = a[0];
    sort(a.begin() + 1, a.end(), cmp);

    int sz = 1;
    int n = a.size();
    for (int i = 2; i < n; ++i) {
        while (sz > 0 && vect(a[i] - a[sz], a[sz] - a[sz - 1]) > -eps) --sz;
        a[++sz] = a[i];
    }
    a.resize(sz + 1);
    return a;
}

int n;
const int N = 100;
int x[N];
int y[N];
int z[N];


double calc(int zz) {

    vector<pt> a;
    for (int i = 0; i < n; ++i) {
        if (z[i] == zz) {
            a.push_back(pt(x[i], y[i]));
        }
    }
    for (int i = 0; i < n; ++i) {
        if (z[i] == zz) {
            continue;
        }
        for (int j = i + 1; j < n; ++j) {
            if (z[j] == zz) {
                continue;
            }

            if (z[i] < zz && z[j] < zz) continue;
            if (z[i] > zz && z[j] > zz) continue;

            pt v(x[j] - x[i], y[j] - y[i]);
            double q = (double)(zz - z[i]) / (z[j] - z[i]);
            pt add = pt(x[i], y[i]) + v * q;
            a.push_back(add);
        }
    }
    double ret = square(convex(a));
    return ret;
}
inline void solve() {
    n = nxt();
    int zmin = nxt();
    int zmax = nxt();

    for (int i  = 0; i < n; ++i) {
        x[i] = nxt();
        y[i] = nxt();
        z[i] = nxt();
    }


    for (int zz = zmin; zz <= zmax; ++zz) {
        cout << setprecision(10) << fixed << calc(zz) << "\n";
    }
}
int main()
{
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif // LOCAL

    solve();

    return 0;
}
