#include <bits/stdc++.h>

#define pb puah_back
#define mp make_pair
#define all(x) (x).begin(), (x).end()
#define x first
#define y second

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef int itn;
typedef pair<int, int> PII;

long double eps = 1e-8;

int nxt() {
    int n;
    scanf("%d", &n);
    return n;
}

struct pt {
    long double x, y, z;
    pt(){}
    pt(long double x, long double y, long double z) : x(x), y(y), z(z) {}

    pt operator - (const pt &r) const {
        return pt(x - r.x, y - r.y, z - r.z);
    }
    pt operator + (const pt &r) const {
        return pt(x + r.x, y + r.y, z + r.z);
    }

    pt operator * (const long double &r) const {
        return pt(x * r, y * r, z * r);
    }

    friend pt vect(const pt &l, const pt &r) {
        return pt(l.y * r.z - l.z * r.y,
                  l.z * r.x - l.x * r.z,
                  l.x * r.y - l.y * r.x);
    }

    long double len() const {
        return sqrtl(fabsl(x * x + y * y + z * z));
    }

    friend long double scal(const pt &l, const pt &r) {
        return l.x * r.x + l.y * r.y + l.z * r.z;
    }

    bool operator < (const pt &r) const {
        return z < r.z;
    }
};

struct plane {
    pt n, t;
    plane(){}
    plane(const pt &a, const pt &b, const pt &c) {
        n = vect(a - c, b - c);
        t = a;
    }

    void revert() {
        n.x *= -1;
        n.y *= -1;
        n.z *= -1;
    }
    long double dist(const pt &c) {
        return scal(c - t, n) / sqrtl(fabsl(scal(n, n)));
    }

    bool operator == (const plane &r) const {
        return vect(n, r.n).len() < eps && fabsl(scal(n, t - r.t)) < eps;
    }
};


vector<plane> getPlanes(pt a[], int n) {
    vector<plane> aa;
    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            for (int k = j + 1; k < n; ++k) {
                plane pl = plane(a[i], a[j], a[k]);

                int cntle = 0;
                int cntmo = 0;
                for (int t = 0; t < n; ++t) {
                    long double di = pl.dist(a[t]);
                    if (di < -eps) {
                        ++cntle;
                    }
                    if (di > eps) {
                        ++cntmo;
                    }
                }

                if (cntle > 0 && cntmo > 0) {
                    continue;
                }
                if (cntle > 0) {
                    pl.revert();
                }
                aa.push_back(pl);
            }
        }
    }
    return aa;
}

long double volume(const pt &a, const pt &b, const pt &c, const pt &d) {
    return fabsl(scal(a - d, vect(b - d, c - d)));
}

void myunique(vector<plane> &a) {
    vector<plane> ret;
    for (int i = 0; i < (int)a.size(); ++i) {
        bool ok = true;
        for (int j = 0; j < (int)ret.size(); ++j) {
            if (ret[j] == a[i]) {
                ok = false;
                break;
            }
        }
        if (ok) {
            ret.push_back(a[i]);
        }
    }
    a = ret;
    return;
}

void solve(){
    int n = nxt();

    pt a[n];


    for (int i = 0; i < n; ++i) {
        a[i].x = nxt();
        a[i].y = nxt();
        a[i].z = nxt();
    }
    int m = nxt();
    pt b[m];
    for (int i = 0; i < m; ++i) {
        b[i].x = nxt();
        b[i].y = nxt();
        b[i].z = nxt();
    }

    vector<plane> aa = getPlanes(a, n);
    vector<plane> bb = getPlanes(b, m);

    myunique(aa);
    myunique(bb);


    vector<vector<pt> > aaa;
    for (int i = 0; i < (int)aa.size(); ++i) {
        vector<pt> pts;
        for (int j = 0; j < n; ++j) {
            if (fabsl(aa[i].dist(a[j])) < eps) {
                pts.push_back(a[j]);
            }
        }
        if (!pts.empty()) {
            aaa.push_back(pts);
        }
    }

    for (int i = 0; i < (int)aaa.size(); ++i) {
        stable_sort(all(aaa[i]));
        stable_sort(aaa[i].begin() + 1, aaa[i].end(), [&](const pt &l, const pt &r)
         {
             return scal(vect(l - aaa[i][0], r - aaa[i][0]), aa[i].n) < 0;
         });
    }

    vector<vector<pt> > bbb;
    for (int i = 0; i < (int)bb.size(); ++i) {
        vector<pt> pts;
        for (int j = 0; j < m; ++j) {
            if (fabsl(bb[i].dist(b[j])) < eps) {
                pts.push_back(b[j]);
            }
        }
        if (!pts.empty()) {
            bbb.push_back(pts);
        }
    }
    for (int i = 0; i < (int)bbb.size(); ++i) {
        stable_sort(all(bbb[i]));
        stable_sort(bbb[i].begin() + 1, bbb[i].end(), [&](const pt &l, const pt &r)
         {
             return scal(vect(l - bbb[i][0], r - bbb[i][0]), bb[i].n) < 0;
         });
    }

    pt ca = pt(0, 0, 0);
    double vola = 0;
    for (int i = 0; i < (int)aaa.size(); ++i) {
        for (int j = 1; j + 1 < (int)aaa[i].size(); ++j) {
            double vol = volume(a[0], aaa[i][0], aaa[i][j], aaa[i][j + 1]);
            pt c1 = a[0] + aaa[i][0] + aaa[i][j] + aaa[i][j + 1];
            vola += vol;
            ca = ca + c1 * 0.25 * vol;
        }
    }
    ca = ca * (1.0 / vola);
//    cout << vola << endl;

//
//    for (auto v : aaa) {
//        for (pt q : v) {
//            cout << q.x << " " << q.y << " " << q.z << endl;
//        }
//        cout << endl;
//    }

    pt cb = pt(0, 0, 0);
    double volb = 0;
    for (int i = 0; i < (int)bbb.size(); ++i) {
        for (int j = 1; j + 1 < (int)bbb[i].size(); ++j) {
            double vol = volume(b[0], bbb[i][0], bbb[i][j], bbb[i][j + 1]);
            pt c1 = b[0] + bbb[i][0] + bbb[i][j] + bbb[i][j + 1];
            volb += vol;
            cb = cb + c1 * 0.25 * vol;
        }
    }
    cb = cb * (1.0 / volb);


    double dista[aa.size()];
    for (int i = 0; i < (int)aa.size(); ++i) {
        dista[i] = fabsl(aa[i].dist(ca));
    }
    double distb[bb.size()];
    for (int i = 0; i < (int)bb.size(); ++i) {
        distb[i] = fabsl(bb[i].dist(cb));
    }

//    cout << ca.x << " " << ca.y << " " << ca.z << endl;
//    cout << cb.x << " " << cb.y << " " << cb.z << endl;
//    cout << aa.size() << " " << bb.size() << endl;

    double ans = 1e19;
    for (int i = 0; i < (int)aa.size(); ++i) {
        for (int j = 0; j < (int)bb.size(); ++j) {
            ans = min(ans, dista[i] + distb[j]);
        }
    }

    cout << setprecision(10) << fixed << ans << endl;
}

int main()
{
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif // LOCAL

    solve();

    return 0;
}
