#include <bits/stdc++.h>

#define pb push_back
#define mp make_pair
#define all(x) (x).begin(), (x).end()
#define x first
#define y second

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef int itn;
typedef pair<int, int> PII;

int nxt() {
    int n;
    scanf("%d", &n);
    return n;
}

const long double eps = 1e-8;

struct pt {
    long double x, y;
    pt() {}
    pt(const long double &x, const long double &y) : x(x), y(y) {}

    pt operator - (const pt &r) const {
        return pt(x - r.x, y - r.y);
    }

    pt operator + (const pt &r) const {
        return pt(x + r.x, y + r.y);
    }

    pt operator * (const double &r) const {
        return pt(x * r, y * r);
    }

    friend long double scal(const pt &l, const pt &r) {
        return l.x * r.x + l.y * r.y;
    }
    friend long double vect(const pt &l, const pt &r) {
        return l.x * r.y - l.y * r.x;
    }
    long double lenSQ() const {
        return fabsl(x * x + y * y);
    }

    bool operator < (const pt &r) const {
        if (fabsl(x - r.x) > eps) {
            return x < r.x;
        }
        return y < r.y;
    }

    bool operator == (const pt &r) const {
        return fabs(x - r.x) < eps && fabs(y - r.y) < eps;
    }
};

struct line {
    double k, b;
    line() {}
};


const long double inf = 1e18;

bool cmpUp(const line &l, const line &r) {
    if (fabs(l.k - r.k) < eps) {
        return l.b > r.b;
    }
    return l.k > r.k;
}


bool cmpDown(const line &l, const line &r) {
    if (fabs(l.k - r.k) < eps) {
        return l.b < r.b;
    }
    return l.k < r.k;
}


bool popUp(const line &l1, const line &l2, const line &l3) {
    return (l2.k - l3.k) * (l2.b - l1.b) > (l1.k - l2.k) * (l3.b - l2.b);
}

bool popDown(const line &l1, const line &l2, const line &l3) {
    return (l2.k - l3.k) * (l2.b - l1.b) < (l1.k - l2.k) * (l3.b - l2.b);
}

inline pt getPoint(const line &l, const double &x) {
    return pt(x, l.k * x + l.b);
}

pt intersect(const line &l, const line &r) {
    assert(fabsl(l.k - r.k) > 1e-18);
    double x = (r.b - l.b) / (l.k - r.k);
    return getPoint(l, x);
}

vector<pt> convexUp(vector<line> &a) {
    sort(all(a), cmpUp);
    int n = a.size();

    int sz = 1;
    for (int i = 1; i < n; ++i) {
        if (fabs(a[sz - 1].k - a[i].k) < eps) {
            a[sz - 1] = a[i];
        } else {
            a[sz++] = a[i];
        }
    }
    a.resize(sz);
    if (a.empty()) {
        return vector<pt>();
    }
    if (a.size() == 1) {
        vector<pt> ret;
        ret.pb(getPoint(a.back(), -inf));
        ret.pb(getPoint(a.back(), inf));
        return ret;
    }

    n = sz;
    sz = 2;
    for (int i = 2; i < n; ++i) {
        while (sz > 1 && popUp(a[sz - 2], a[sz - 1], a[i])) {
            --sz;
        }
        a[sz++] = a[i];
    }
    a.resize(sz);
    vector<pt> ret;
    if (a.empty()) {
        return ret;
    }
    n = a.size();

    //cout << "asdasdassda " << n << endl;
    ret.push_back(getPoint(a[0], -inf));
    for (int i = 1; i < n; ++i) {
        ret.push_back(intersect(a[i], a[i - 1]));
    }
    ret.push_back(getPoint(a.back(), inf));

    return ret;
}


vector<pt> convexDown(vector<line> &a) {
    sort(all(a), cmpDown);
    int n = a.size();
    int sz = 1;
    for (int i = 1; i < n; ++i) {
        if (fabs(a[sz - 1].k - a[i].k) < eps) {
            a[sz - 1] = a[i];
        } else {
            a[sz++] = a[i];
        }
    }

    a.resize(sz);
    if (a.empty()) {
        return vector<pt>();
    }
    if (a.size() == 1) {
        vector<pt> ret;
        ret.pb(getPoint(a.back(), -inf));
        ret.pb(getPoint(a.back(), inf));
        return ret;
    }

    n = sz;
    sz = 2;
    for (int i = 2; i < n; ++i) {
        while (sz > 1 && popDown(a[sz - 2], a[sz - 1], a[i])) {
            --sz;
        }
        a[sz++] = a[i];
    }
    a.resize(sz);


    vector<pt> ret;
    if (a.empty()) {
        return ret;
    }
    n = a.size();
    ret.push_back(getPoint(a[0], -inf));
    for (int i = 1; i < n; ++i) {
        ret.push_back(intersect(a[i], a[i - 1]));
    }
    ret.push_back(getPoint(a.back(), inf));

    return ret;
}

void solve(){
    int n = nxt();
    double a[n];
    double b[n];
    double c[n];

    double phi = rand();
    double co = cos(phi);
    double si = sin(phi);

    for (int i = 0; i < n; ++i) {
        a[i] = nxt();
        b[i] = nxt();
        c[i] = nxt();

        double aa = a[i] * co + si * b[i];
        double bb = -si * a[i] + co * b[i];
        a[i] = aa;
        b[i] = bb;
    }

    vector<line> ma;
    vector<line> mi;
    for (int i = 0; i < n; ++i) {
        line l;
        l.k = -a[i] / b[i];
        l.b =  c[i] / b[i];
        if (b[i] > eps) {
            ma.push_back(l);
        } else {
            mi.push_back(l);
        }
    }

//    cout << "MA" << endl;
//    for (int i = 0; i < ma.size(); ++i) {
//            cout << ma[i].k << " " << ma[i].b << endl;
//    }
//    cout << endl;
//    cout << "MI" << endl;
//    for (int i = 0; i < mi.size(); ++i) {
//            cout << mi[i].k << " " << mi[i].b << endl;
//    }
//    cout << endl;


    vector<pt> aa = convexUp(ma);
    vector<pt> bb = convexDown(mi);

//    for (int i = 0; i < aa.size(); ++i) {
//        cout << aa[i].x << " " << aa[i].y << endl;
//    }
//    cout << endl;
//    for (int i = 0; i < bb.size(); ++i) {
//        cout << bb[i].x << " " << bb[i].y << endl;
//    }
//    cout << endl;

    if (aa.empty() || bb.empty()) {
        cout << "-1" << endl;
        return;
    }

    vector<double> xs;
    for (int i = 0; i < (int)aa.size(); ++i) {
        xs.push_back(aa[i].x);
   }
   for (int i = 0; i < (int)bb.size(); ++i) {
        xs.push_back(bb[i].x);
    }
    sort(all(xs));
    xs.resize(unique(all(xs), [&](const double &l, const double &r){
                        return fabs(l - r) < eps;
                     }) - xs.begin());

    if (aa.front().y > bb.front().y + eps) {
        cout << "-1" << endl;
        return;
    }

    if (aa.back().y > bb.back().y + eps) {
        cout << "-1" << endl;
        return;
    }
    double xmin = INT_MAX;
    double xmax = INT_MIN;
    for (int i = 1, j = 0, k = 0; i + 1 < (int)xs.size(); ++i) {
        while (j < (int)aa.size() && aa[j].x + eps < xs[i]) {
            ++j;
        }
        while (k < (int)bb.size() && bb[k].x + eps < xs[i]) {
            ++k;
        }
        double y1 = getPoint(ma[j - 1], xs[i]).y;
        double y2 = getPoint(mi[k - 1], xs[i]).y;
        if (y1 < y2) {
            continue;
        }
//        cout << "XMIN" << endl;
//        cout << j << " " << k << endl;
        xmin = intersect(ma[j - 1], mi[k - 1]).x;
        break;
    }

    for (int i = (int)xs.size() - 2, j = (int)aa.size() - 1, k = (int)bb.size() - 1; i > 0; --i) {
        while (j >= 0 && aa[j].x - eps > xs[i]) {
            --j;
        }
        while (k >= 0 && bb[k].x - eps > xs[i]) {
            --k;
        }
        double y1 = getPoint(ma[j], xs[i]).y;
        double y2 = getPoint(mi[k], xs[i]).y;
        if (y1 < y2) {
            continue;
        }
        xmax = intersect(ma[j], mi[k]).x;
        break;
    }

//   cout << xmin << " " << xmax << endl;
    if (xmax < xmin) {
        cout << "0\n";
        return;
    }

    vector <double> u;
    u.push_back(xmin);
    for (int i = 0; i < (int)xs.size(); ++i) {
        if (xs[i] > xmin + eps && xs[i] < xmax - eps) {
            u.pb(xs[i]);
        }
    }
    u.pb(xmax);

    double ans = 0;
    for (int i = 1, j = 0, k = 0; i < (int)u.size(); ++i) {
        while (j < (int)aa.size() && aa[j].x + eps < u[i]) {
            ++j;
        }
        while (k < (int)bb.size() && bb[k].x + eps < u[i]) {
            ++k;
        }
        double y1 = getPoint(ma[j - 1], u[i]).y - getPoint(mi[k - 1], u[i]).y;
        double y2 = getPoint(ma[j - 1], u[i - 1]).y - getPoint(mi[k - 1], u[i - 1]).y;
        ans += (y1 + y2) * (u[i] - u[i - 1]);
    }
    ans /= 2;
    cout << setprecision(10) << fixed;
    cout << ans << endl;
}


int main()
{
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif // LOCAL

    solve();

    return 0;
}
