#include <iostream>
#include <vector>
#include <bitset>
#include <algorithm>
#include <queue>
#include <cstdio>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>

using namespace std;
typedef int huint;
typedef long long ll;
#define mp make_pair
#define pb push_back
#define all(x) x.begin(),x.end()

struct v2{
	int x, y, id;
	v2() {}
	v2(const int x, const int y, const int id): x(x), y(y), id(id) {}
	v2(const int x, const int y): x(x), y(y) {}
	v2 operator +(const v2& r) const{
		return v2(x + r.x, y + r.y); }
	v2 operator -(const v2& r) const{
		return v2(x - r.x, y - r.y); }
	double sqlen() const{
		return x * x + y * y; }
	bool operator <(const v2& r) {
		return x < r.x || x == r.x && y < r.y; }
};
int dot(const v2& l, const v2& r) {
	return l.x * r.x + l.y * r.y;
}
int cross(const v2& l, const v2& r) {
	return l.x * r.y - l.y * r.x;
}

struct CMP{
	v2 O;
	CMP(const v2& O): O(O) {}
	bool operator () (const v2& l, const v2& r){
		int s = cross(l - O, r - O);
		return s > 0 || s == 0 && (l - O).sqlen() < (r - O).sqlen();
	}
};

const int N = 20001;
int ans[N];
inline void f(vector<v2>& pts){
	vector<v2> hull;
	int cur = 0;
	int sotredbyid = pts[0].id;
	sort(pts.begin(), pts.end());
	vector<v2> t;
	vector<v2> up, dn;
	while (pts.size() > 0) {
		++cur;
		up.resize(0);
		dn.resize(0);
		ans[pts[0].id] = cur;
		ans[pts.back().id] = cur;
		up.push_back(pts[0]);
		dn.push_back(pts[0]);
		for (int i = 1; i < pts.size(); ++i) {
			v2 x = pts[i];
			int s = cross(pts.back() - pts[0], x - pts[0]);
			while (up.size() > 1 && cross(up.back() - up[up.size() - 2], x - up.back()) > 0) up.pop_back();
				up.push_back(x);
			while (dn.size() > 1 && cross(dn.back() - dn[dn.size() - 2], x - dn.back()) < 0) dn.pop_back();
				dn.push_back(x);
		}
		for (int i = 0; i < up.size(); ++i)
			ans[up[i].id] = cur;
		for (int i = 0; i < dn.size(); ++i)
			ans[dn[i].id] = cur;
		t.resize(0);
		for (int i = 0; i < pts.size(); ++i)
			if (ans[pts[i].id] == 0)
				t.push_back(pts[i]);
		swap(t, pts);
	}
}

int main(){
	ios_base::sync_with_stdio(false);
	int n;
	cin >> n;
	vector<v2> v(n);
	for (int i = 0; i < n; ++i){
		cin >> v[i].x >> v[i].y;
		v[i].id = i;
	}
	f(v);
	for (int i = 0; i < n; ++i)
		cout << ans[i] << endl;
	return 0;
}