#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <cassert>
#include <ctime>
#include <cstring>
#include <algorithm>
#include <iostream>
#include <set>
#include <map>
#include <vector>
#include <queue>
#include <deque>
using namespace std;
#define pb push_back
#define mp make_pair
#define sc second
#define fs first
#define int64 long long
#define ldb long double
#define sz(a) ((int) (a).size())
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
const int N = 20000 + 10;

struct pt {
	int x, y;
	pt(int x, int y): x(x), y(y) {}
	pt() {}
} p[N], base;
int color[N], n, cnt;

pt operator-(const pt& a, const pt& b) {
	return pt(a.x - b.x, a.y - b.y);
}

pt operator+(const pt& a, const pt& b) {
	return pt(a.x + b.x, a.y + b.y);
}

int det2(const int& a, const int& b, const int& c, const int& d) {
	return a * d - b * c;
}

int vmul(const pt& a, const pt& b) {
	return det2(a.x, a.y, b.x, b.y);
}

int sqr(int x) {
	return x * x;
}

int dist(const pt& a, const pt& b) {
	return sqr(a.x - b.x) + sqr(a.y - b.y);
}

bool cmp_base(const pt& a, const pt& b) {
	int vm = vmul(a - base, b - base);
	if (vm != 0) return (vm > 0);
	return dist(a, base) < dist(b, base);
}

bool cmp_pair(const pt& a, const pt& b) {
	return mp(a.x, a.y) < mp(b.x, b.y);
}

int main() {
	/*assert(freopen("input.txt", "w", stdout));
	const int n = 20000;
	const int r = 10000;
	const double pi = acos(-1.0);
	printf("%d\n", n);
	for (int i = 0; i < n; ++i)
		printf("%d %d\n", rand() % 20000 - 10000, rand() % 20000 - 10000);
		//printf("%d %d\n", (int) floor(r * cos(i * 2 * pi / n)), (int) floor(r * sin(i * 2 * pi / n)));
	return 0;*/
	//double start = clock();
	//assert(freopen("input.txt", "r", stdin));
	//assert(freopen("output.txt", "w", stdout));
	scanf("%d", &n);
	for (int i = 0; i < n; ++i) {
		scanf("%d%d", &p[i].x, &p[i].y);
		color[i] = n;
	}
	while (true) {
		int start = -1;
		for (int i = 0; i < n; ++i)
			if ((color[i] == n) && ((start == -1) || cmp_pair(p[i], p[start]))) start = i;
		if (start == -1) break;
		int i = start;
		do {
			base = p[i];
			color[i] = cnt;
			int nxt = -1;
			for (int j = 0; j < n; ++j)
				if ((color[j] >= cnt) && ((nxt == -1) || cmp_base(p[nxt], p[j])))
					nxt = j;
			i = nxt;
		} while (i != start);
		++cnt;
	}
	for (int i = 0; i < n; ++i)
		printf("%d\n", color[i] + 1);
	//eprintf("%.2lf\n", (clock() - start) / CLOCKS_PER_SEC);
	return 0;
}