#include <iostream> 
#include <cstdio> 
#include <map> 
#include <set>  
#include <cstdlib> 
#include <cstring>
#include <cassert>
#include <utility>
#include <vector>
#include <string>
#include <queue>
#include <fstream> 
#include <iomanip> 
#include <sstream> 
#include <cmath> 
#include <ctime> 
#include <cctype> 
#include <deque>
#include <algorithm>

#define pb push_back
#define mp make_pair

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair< int, int > pii;
typedef vector< int > vi;

template <class T> inline void updMax(T &x, const T &other) { if (x < other) x = other; }
template <class T> inline void updMin(T &x, const T &other) { if (other < x) x = other; }
template <class T> inline T sqr(const T &x) { return x * x; } 

struct Point3D
{
	ll x, y, z;
	Point3D(ll x_ = 0, ll y_ = 0, ll z_ = 0) : x(x_), y(y_), z(z_) {}
	Point3D operator+(const Point3D &lhs) const
	{
		return Point3D(x + lhs.x, y + lhs.y, z + lhs.z);
	}
	Point3D operator-(const Point3D &lhs) const
	{
		return Point3D(x - lhs.x, y - lhs.y, z - lhs.z);
	}
	Point3D operator^(const Point3D &lhs) const
	{
		return Point3D(y * lhs.z - z * lhs.y, z * lhs.x - x * lhs.z, x * lhs.y - y * lhs.x);
	}
	ll operator*(const Point3D &lhs) const
	{
		return (x * lhs.x + y * lhs.y + z * lhs.z);
	}
	ll sqLen() const
	{
		return x * x + y * y + z * z;
	}
	Point3D operator*(const ll coeff) const
	{
		return Point3D(x * coeff, y * coeff, z * coeff);
	}
	friend istream&operator>>(istream &in, Point3D &p)
	{
		return in >> p.x >> p.y >> p.z;
	}
};

bool
canReach(Point3D &p, Point3D &p1, Point3D &p2, Point3D &p3, ll dist)
{
	Point3D proj = (p2 - p1) ^ (p3 - p1);
	ll projVal = ((p - p1) * proj);
	ll k = (projVal * projVal) / (proj * proj);
	ll pp = (projVal * projVal) % (proj * proj);
	return k < dist * dist || (k == dist * dist && pp == 0ll);
}

int main()
{
	//freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
	//freopen(".in", "r", stdin); freopen(".out", "w", stdout);
	
	//ios::sync_with_stdio(false); 
	
	vector< Point3D > allPoints(5);
	int m, h, H;
	cin >> m >> h >> H;
	cin >> allPoints[0].x >> allPoints[0].y;
	allPoints[0].z = h;
	for (int i = 1; i <= 4; ++i) {
		cin >> allPoints[i].x >> allPoints[i].y;
	}
	allPoints[4].z = H;
	bool can = false;
	if (m >= h) {
		m -= h;
		can = canReach(allPoints[0], allPoints[1], allPoints[2], allPoints[3], m)
			|| canReach(allPoints[0], allPoints[1], allPoints[3], allPoints[4], m)
			|| canReach(allPoints[0], allPoints[1], allPoints[2], allPoints[4], m)
			|| canReach(allPoints[0], allPoints[2], allPoints[3], allPoints[4], m);
	}
	if (can) {
		cout << "YES\n";
	} else {
		cout << "NO\n";
	}
	return 0;
}