#include <iostream> 
#include <cstdio> 
#include <map> 
#include <set> 
#include <algorithm> 
#include <cstdlib> 
#include <cstring>
#include <cassert>
#include <utility>
#include <vector>
#include <string>
#include <queue>
#include <fstream> 
#include <iomanip> 
#include <sstream> 
#include <cmath> 
#include <ctime> 
#include <cctype> 
#include <deque> 

#define pb push_back
#define mp make_pair

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair< int, int > pii;
typedef vector< int > vi;

template <class T> inline void updMax(T &x, const T &other) { if (x < other) x = other; }
template <class T> inline void updMin(T &x, const T &other) { if (other < x) x = other; }
template <class T> inline T sqr(const T &x) { return x * x; } 


struct Point {
	ld x, y; 
	Point(ld _x = 0, ld _y = 0) : x(_x), y(_y) {}; 
	Point operator-(const Point &lhs) const
	{
		return Point(x - lhs.x, y - lhs.y);
	}
	ld operator^(const Point &lhs) const
	{
		return x * lhs.y - y * lhs.x;
	}
	ld operator*(const Point &lhs) const
	{
		return x * lhs.x + y * lhs.y;
	}
}; 

ld dist(Point a, Point b) {
	return sqr(a.x - b.x) + sqr(a.y - b.y); 
}

double x, y; 
Point p; 
Point pinit(0, 0); 

const double eps = 1e-6;

bool isOnSegment(Point a, Point p1, Point p2)
{
	return fabs((p2 - p1) ^ (a - p1)) < 1e-9
		&& ((p2 - p1) * (a - p1)) > -1e-9
		&& ((p1 - p2) * (a - p2)) > -1e-9;
}

int getcross(Point a, Point b, Point c, Point d) {
	if (isOnSegment(b, c, d)) {
		return false;
	}
	if (isOnSegment(a, c, d)) {
		return true;
	}
	if (((b - a) ^ (c - a)) * ((b - a) ^ (d - a)) > 1e-9) {
		return false;
	}
	if (((d - c) ^ (a - c)) * ((d - c) ^ (b - c)) > 1e-9) {
		return false;
	}
	ld ax = min(a.x, b.x), bx = max(a.x, b.x);
	ld ay = min(a.y, b.y), by = max(a.y, b.y);
	ld cx = min(c.x, d.x), dx = max(c.x, d.x);
	ld cy = min(c.y, d.y), dy = max(c.y, d.y);
	if (max(ax, cx) > min(bx, dx) + 1e-9 || max(ay, cy) > min(by, dy) + 1e-9) {
		return false;
	}
	return true;
}


double f(Point a, Point b, Point c, ld area) {
	int cnt = getcross(a, b, pinit, p) + getcross(b, c, pinit, p) + getcross(c, a, pinit, p); 
	if (cnt >= 2) return area; 
	
	if (cnt == 0 || area < eps) return 0; 
	Point na = a, nb = b, nc = c; 
	Point na2 = a, nb2 = b, nc2 = c; 
	if (dist(a, b) > dist(a, c) && dist(a, b) > dist(b, c)) {
		na2.x = nb.x = (a.x + b.x) / 2; 
		na2.y = nb.y = (a.y + b.y) / 2; 
	}
	if (dist(a, c) > dist(a, b) && dist(a, c) > dist(b, c)) {
		na2.x = nc.x = (a.x + c.x) / 2; 
		na2.y = nc.y = (a.y + c.y) / 2; 
	}
	if (dist(b, c) > dist(a, b) && dist(b, c) > dist(a, c)) {
		nb2.x = nc.x = (b.x + c.x) / 2; 
		nb2.y = nc.y = (b.y + c.y) / 2; 
	}
	return f(na, nb, nc, area / 2) + f(na2, nb2, nc2, area / 2); 
}

int main()
{
	//freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
	//freopen(".in", "r", stdin); freopen(".out", "w", stdout);
	
	ios::sync_with_stdio(false); 
	
	cin >> x >> y; 
	p = Point(x, y); 
	
	cout.precision(20); 
	cout.setf(ios::fixed); 

	cout << f(Point(0, 0), Point(10, 0), Point(10, 10), 50) << endl; 

	return 0;
}