#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <ctime>
#include <cstring>
#include <cassert>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <bitset>
#include <stack>
#include <queue>
#include <deque>
#include <complex>

using namespace std;

#define pb push_back
#define mp make_pair
#define sz(s) int((s).size())
#define len(s) int((s).size())
#define all(s) (s).begin(), (s).end()
#ifdef _WIN32
#define LLD "%I64d"
#else
#define LLD "%lld"
#endif
#ifdef LOCAL42
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#else
#define eprintf(...) 42
#endif
#define y0 yy0
#define y1 yy1
#define next _next
#define prev _prev
#define rank _rank
#define link _link
#define hash _hash
#define fs first
#define sc second

typedef long long ll;
typedef long long llong;
typedef long long int64;
typedef unsigned int uint;
typedef long double ld;
typedef unsigned long long ull;
typedef unsigned long long ullong;
typedef unsigned long long lint;
typedef pair<int, int> pii;
typedef vector<int> vi;

const int inf = int(1e9);
const double eps = 1e-9;
const double pi = 4 * atan(double(1));

struct vt
{
	double x, y;
	vt(){}
	vt(double _x, double _y)
	{
		x = _x, y = _y;
	}
	friend vt operator +(vt a, vt b)
	{
		return vt(a.x + b.x, a.y + b.y);
	}
	friend double operator ^(vt a, vt b)
	{
		return a.x * b.y - b.x * a.y;
	}
	friend vt operator -(vt a, vt b)
	{
		return vt(a.x - b.x, a.y - b.y);
	}
	friend double operator *(vt a, vt b)
	{
		return a.x * b.x + a.y * b.y;
	}
	friend vt operator /(vt v, double k)
	{
		return vt(v.x / k, v.y / k);
	}
	friend vt operator *(vt v, double k)
	{
		return vt(v.x * k, v.y * k);
	}
	friend bool operator <(vt a, vt b)
	{
		return make_pair(a.x, a.y) < make_pair(b.x, b.y);
	}
	friend bool operator ==(vt a, vt b)
	{
		return fabs(a.x - b.x) + fabs(a.y - b.y) < eps;
	}
};

const int N = 10500;

struct vt3
{
	double x, y, z;
	vt3(double _x, double _y, double _z)
	{
		x = _x, y = _y, z = _z;
	}
	friend vt3 operator +(vt3 a, vt3 b)
	{
		return vt3(a.x + b.x, a.y + b.y, a.z + b.z);
	}
	friend vt3 operator -(vt3 a, vt3 b)
	{
		return vt3(a.x - b.x, a.y - b.y, a.z - b.z);
	}
	friend vt3 operator *(vt3 a, double k)
	{
		return vt3(a.x * k, a.y * k, a.z * k);
	}
	friend vt3 operator /(vt3 a, double k)
	{
		return vt3(a.x / k, a.y / k, a.z / k);
	}
	vt3(){}
} P[N];

vector<vt> A;

struct cmp
{
	vt o;
	cmp(vt _o)
	{
		o = _o;
	}
	bool operator() (vt a, vt b)
	{
		a = a - o, b = b - o;
		double v = (a ^ b);
		if (fabs(v) < eps)
			return a * a < b * b;
		else
			return v > eps;
	}
};

int pt = 0;
vt st[N];

double convex()
{
	pt = 0;
	sort(A.begin(), A.end());
	A.resize(unique(A.begin(), A.end()) - A.begin());
	rotate(A.begin(), min_element(A.begin(), A.end()), A.end());
	sort(A.begin() + 1, A.end(), cmp(A.front()));
	st[pt++] = A[0];
	for (int i = 1; i < A.size(); i++)
	{
		vt x = A[i];
		while (pt >= 2)
		{
			vt b = st[pt - 1];
			vt a = st[pt - 2];
			if (((b - a) ^ (x - b)) < eps)
				--pt;
			else
				break;
		}
		st[pt++] = x;
	}
	double ans = 0;
	for (int i = 0; i < pt; i++)
		ans += (st[i] ^ st[(i + 1) % pt]) / 2;
	return ans;
}


int main() {
#ifdef LOCAL42
#define TASK "A"
	freopen(TASK ".in", "r", stdin);
	freopen(TASK ".out", "w", stdout);
#else

#endif
	int n;
	int zmin, zmax;
	scanf("%d %d %d", &n, &zmin, &zmax);
	for (int i = 0; i < n; i++)
	{
		scanf("%lf %lf %lf", &P[i].x, &P[i].y, &P[i].z);
	}
	for (int z = zmin; z <= zmax; z++)
	{
		A.clear();
		for (int i = 0; i < n; i++)
			for (int j = 0; j < n; j++)
			{
				if (i == j)
					continue;
				vt3 a = P[i], b = P[j];
				if (fabs(a.z - b.z) < eps)
					continue;
				if (a.z > b.z)
					swap(a, b);
				if (a.z - eps > z || b.z + eps < z)
					continue;
				vt3 r = (a * (b.z - z) + b * (z - a.z)) / (b.z - a.z);
				A.push_back(vt(r.x, r.y));
			}

		double ans = 0;
		if (A.empty())
			ans = 0;
		else
			ans = convex();
		printf("%.10lf\n", ans);
	}
	return 0;
}
