#include <iostream>
#include <cstdio>
#include <vector>
#include <string>
#include <cstring>
#include <cstdlib>
#include <algorithm>
#include <map>
using namespace std;


void cycle()
{
	while (true)
	{
		printf(" ");
	}
}

int smallRand()
{
	return (rand() & ((1 << 15) - 1));
}

int myRand()
{
	return ((smallRand() << 15) ^ smallRand());
}

long long myRandLL()
{
	return ((((long long)myRand()) << 30) ^ (long long)myRand());
}

const int maxn = 100500;
int down[maxn];
int e[maxn][2];
long long eh[maxn];
bool used[maxn];
vector <int> g[maxn];
bool bad[maxn];
int par[maxn];

int getP(int x)
{
	if (x != par[x])
		par[x] = getP(par[x]);
	return par[x];
}
bool uni(int x, int y)
{
	x = getP(x);
	y = getP(y);
	if (x == y)
		return false;
	if (rand() & 1)
		swap(x, y);
	par[x] = y;
	return true;
}

int getOther(int eid, int v)
{
	return e[eid][0] + e[eid][1] - v;
}

vector <pair <long long, pair<int, int> > > hup, nup;
vector <long long> edges;

long long dfs(int v, int gid = -1, int h = 0)
{
	if (gid != -1)
	{
		bad[gid] = false;
		down[gid] = v;
	}
	long long ans = 0;
	used[v] = true;
	for (int i = 0; i < (int)g[v].size(); i++)
	{
		int eid = g[v][i];
		int nv = getOther(eid, v);
		if (!used[nv])
			ans ^= dfs(nv, eid, h + 1);
		else if (eid != gid)
			ans ^= eh[eid];
	}
	if (gid != -1)
		hup.push_back(make_pair(ans, make_pair(-h, gid)));

	return ans;
}



int main()
{
#ifndef ONLINE_JUDGE
	freopen("input.txt", "r", stdin);
#endif
	int n, m;
	scanf("%d%d", &n, &m);
	for (int i = 0; i < m; i++)
	{
		scanf("%d%d", &e[i][0], &e[i][1]);
		e[i][0]--;
		e[i][1]--;
		eh[i] = myRandLL();
		g[e[i][0]].push_back(i);
		g[e[i][1]].push_back(i);
		edges.push_back(eh[i]);

		//		fprintf(stderr, "i = %d, %lld\n", i, eh[i] );
	}

	memset(bad, true, sizeof bad);
	for (int i = 0; i < n; i++)
	{
		par[i] = i;
		if (used[i])
			continue;
		dfs(i);
	}
	sort(edges.begin(), edges.end());
	sort(hup.begin(), hup.end());
	for (int i = 0; i < (int)hup.size(); i++)
	{
		if (hup[i].first == 0)
		{
			bad[hup[i].second.second] = true;
			continue;
		}
		int id = lower_bound(edges.begin(), edges.end(), hup[i].first) - edges.begin();
		if (id != (int)edges.size() && edges[id] == hup[i].first)
		{
			bad[hup[i].second.second] = true;
			continue;
		}
		nup.push_back(hup[i]);
	}
	int st = 0;
	for (int i = 0; i <= (int)nup.size(); i++)
	{
		if (i != (int)nup.size() && nup[i].first == nup[st].first)
			continue;

		if (i != st + 1 && i != 0)
		{
			for (int j = st; j < i; j++)
			{
				bad[nup[j].second.second] = true;
			}
			e[m][0] = down[nup[st].second.second];
			e[m][1] = getOther(nup[i - 1].second.second, down[nup[i - 1].second.second]);
			bad[m] = false;
			m++;
			if (m == maxn)
				cycle();
		}
		st = i;
		continue;

	}
	for (int i = 0; i < m; i++)
	{
		if (bad[i])
			continue;
		//	fprintf(stderr, "%d <-> %d\n", e[i][0] + 1, e[i][1] + 1);
		uni(e[i][0], e[i][1]);
	}
	int q;
	scanf("%d", &q);
	for (int i = 0; i < q; i++)
	{
		int a, b;
		scanf("%d%d", &a, &b);
		a--;
		b--;
		if (getP(a) != getP(b))
			printf("No\n");
		else
			printf("Yes\n");
	}

	return 0;
}
