#include <iostream>
#include <algorithm>
#include <set>
#include <map>
#include <string>
#include <cstdio>
#include <ctime>
#include <cassert>
#include <vector>
#include <queue>
#include <cmath>

#define pb push_back
#define mp make_pair
#define fr first
#define sc second
using namespace std;




const long long INF = 1e9;
const long long EPS = 1e-7;
const int N = 111;


struct pnt {
	long long x, y, z;
	pnt() {}
	pnt(long long x, long long y, long long z) : x(x), y(y), z(z) {}
	void scan() {
		cin >> x >> y >> z;
		//scanf("%I64d%I64d%I64d", &x, &y, &z);
	}
	//void scan(long long z) {
		//(*this).z = z;
		//scanf("%l", &x, &y);
	//}
	void Epr() const {
		cerr << "x y z: " << x << " " << y << " " << z << endl;
	}
	pnt operator -(const pnt &A) const {
		return pnt(x - A.x, y - A.y, z - A.z);
	}
	pnt operator +(const pnt &A) const {
		return pnt(x + A.x, y + A.y, z + A.z);
	}
	pnt operator / (const long long k) const {
		return pnt(x / k, y / k, z / k);
	}
	pnt operator * (long long k) {
		return pnt(x * k, y * k, z * k);
	}
	long long operator %(const pnt &A) const {
		return x * A.x + y * A.y + z * A.z;
	}
	pnt operator * (const pnt &A) const {
		return pnt(y * A.z - z * A.y,
			     -x * A.z + z * A.x,
			     x * A.y - y * A.x);
	}
	bool operator == (pnt A) {
		return x == A.x && y == A.y && z == A.z;
	}
};


struct pntD {
	double x, y, z;
	pntD() {}
	pntD(double x, double y, double z) : x(x), y(y), z(z) {}
	void scan(double z) {
		(*this).z = z;
		scanf("%lf%lf", &x, &y);
	}
	void Epr() {
		cerr << "x y z: " << x << " " << y << " " << z << endl;
	}
	pntD operator -(const pntD &A) const {
		return pntD(x - A.x, y - A.y, z - A.z);
	}
	pntD operator +(const pntD &A) const {
		return pntD(x + A.x, y + A.y, z + A.z);
	}
	pntD operator / (const double k) const {
		return pntD(x / k, y / k, z / k);
	}
	pntD operator * (double k) {
		return pntD(x * k, y * k, z * k);
	}
	void init(pnt A) {
		x = A.x;
		y = A.y;
		z = A.z;
	}
	double operator %(const pntD &A) const {
		return x * A.x + y * A.y + z * A.z;
	}
	pntD operator * (const pntD &A) const {
		return pntD(y * A.z - z * A.y,
			     -x * A.z + z * A.x,
			     x * A.y - y * A.x);
	}
	bool operator == (pntD A) {
		return x == A.x && y == A.y && z == A.z;
	}
	double len() {
		double d = x * x + y * y + z * z;
		if (fabs(d) < EPS) d = 0;
		return sqrt(d);
	}
	pntD normalize(double k = 1) {
		return pntD(x * k / len(), y * k / len(), z * k / len());
	}
	double distTo(const pntD & A, const pntD & B, const pntD & C) const {
		pntD E = *this;
		pntD n = (C - A) * (B - A);
		n = n.normalize();
		return n % (A - E);
	}
	int side(const pntD &A, const pntD &B, const pntD &C) const {
		double d = distTo(A, B, C);
		if (d < -EPS) return -1;
		if (d > EPS) return +1;
		return 0;
	}
};




double ans;
int n;
pnt a[N];
pntD g[N];
pnt O;
pnt norm;

long long gcd(long long a, long long b) {
	a = abs(a);	
	b = abs(b);
	return (b == 0)? a: gcd(b, a % b);
}

bool cmp3(pnt a, pnt b) {
	if (a.x != b.x) return a.x < b.x;
	if (a.y != b.y) return a.y < b.y;
	return a.z < b.z;
}

bool eq(pnt a, pnt b) {
	return a == b;
}

bool cmpAng(pnt a, pnt b) {
	a = (a - O);	
	b = (b - O);
	pnt u = a * b;
	return u % norm > 0;
}

pair < pnt, long long > getCentre(pnt A, pnt B, pnt C, pnt D) {
	long long w = ((B - A) * (C - A)) % (D - A);
	w = abs(w);
	pnt S = A + B + C + D;
	return mp(S, w);
}

void solve() {
	vector < pnt > q;
	for (int i = 0; i < n; i++)
		for (int j = i + 1; j < n; j++)
			for (int k = j + 1; k < n; k++) {
				q.pb((a[j] - a[i]) * (a[k] - a[i]));
			}
	for (auto & t: q) {
		long long d = gcd(gcd(t.x, t.y), t.z);
		t = t / d;
		if (t.x < 0 || (t.x == 0 && (t.y < 0 || (t.y == 0 && t.z < 0))))
			t = t * -1;
	}
	sort(q.begin(), q.end(), cmp3);
	q.resize(unique(q.begin(), q.end()) - q.begin());
	int t = q.size();
	for (int i = 0; i < t; i++)
		q.pb(q[i] * -1);

	vector < pair < pnt, long long > > parts;
	for (auto v: q) {
		if (v == pnt(0, 0, 0)) continue;
		vector < pnt > tmp;
		long long dist = - INF * 1ll * INF;
		for (int i = 0; i < n; i++) {
			if (v % a[i] > dist) {
				tmp.clear();
				dist = v % a[i];
			}
			if (v % a[i] == dist)
				tmp.pb(a[i]);
		}
		if ((int)tmp.size() < 3) continue;		
		//cerr << "tmp: " << tmp.size() << endl;
		O = tmp[0];
		norm = v;
		sort(tmp.begin() + 1, tmp.end(), cmpAng);
		for (int i = 1; i < (int)tmp.size() - 1; i++) 	
			parts.pb(getCentre(tmp[0], tmp[i], tmp[i + 1], a[0]));		
	}
	long long sum = 0;	
	pnt sumP = pnt(0, 0, 0);
	for (auto t: parts) {
		sum += t.sc;	
		sumP = sumP + (t.fr * t.sc);
	}
	pntD u;
	u.init(sumP);
	u = u / 4;
	u = u / sum;
	for (int i = 0; i < n; i++)
		g[i].init(a[i]);
	double res = 1e9;
	//cerr << "\n" << endl;
	//u.Epr();
	for (int i = 0; i < n; i++) {
		for (int j = i + 1; j < n; j++) {
			for (int k = j + 1; k < n; k++) {
				int cnt0 = 0, cnt1 = 0;
				for (int e = 0; e < n; e++) {
					if (g[e].side(g[i], g[j], g[k]) < 0) cnt0++; else
					if (g[e].side(g[i], g[j], g[k]) > 0) cnt1++;
				}
				if (cnt0 * cnt1 != 0) continue;
				double cur = fabs(u.distTo(g[i], g[j], g[k]));
				//cerr << cur << endl;
				res = min(res, cur);
			}
		}
	}
	ans += res;
}

int main() {
#ifdef DEBUG
	freopen("in", "r", stdin);
#endif
	//freopen("input.txt", "r", stdin);
	//cerr << gcd(-12, -5) << endl;
	scanf("%d", &n);
	for (int i = 0; i < n; i++) a[i].scan();
	solve();

	scanf("%d", &n);
	for (int i = 0; i < n; i++) a[i].scan();
	solve();

	printf("%.10lf\n", ans);
}

