#include <vector>
#include <algorithm>
#include <iostream>
#include <utility>
#include <cstring>
#include <fstream>
#include <stack>
#include <queue>
#include <set>
#include <iomanip>
#include <cmath>

#define inf 2000000000
#define maxn 20010
#define eps 1e-7

using namespace std;

ifstream fin ("input.txt");
ofstream fout ("output.txt");


struct point
{
    double x,y;
}p,O;

double answer;

double det (point a, point b, point c)
{
    return (b.x - a.x) * (c.y - a.y) - (c.x - a.x) * (b.y - a.y);
}

bool dif0 (double a)
{
    return fabs (a) > eps;
}

bool intersection (point a, point b, point c)
{
    int cnt = 0;
    if (det(O,p,b)*det(O,p,a) <= 0 && det (a,b,O)*det(a,b,p)<=0 && dif0(det(O,p,b)) )
      ++cnt;
    if (det (O,p,c)*det(O,p,b) <= 0 && det (b,c,O)*det(b,c,p)<=0 && dif0 (det(O,p,c)) )
      ++cnt;
    if (det (O,p,a)*det(O,p,c) <= 0 && det (a,c,O)*det(a,c,p) <= 0 && dif0(det(O,p,a)) )
      ++cnt;
    return (cnt >= 2);
}

bool in_poly (point a, point b, point c)
{
    if (det(a,b,p) == 0 || det (b,c,p) == 0 || det (c,a,p) == 0)
      return 0;
    bool sgn = det (a,b,p) > 0;
    return (sgn == (det(b,c,p) > 0) && sgn == (det (c,a,p) > 0) );
}

void solve (point a, point b, point c, double area)
{
    if (area < 1e-4)
     return;

    point d;
    d.x = (b.x+c.x)/2;
    d.y = (b.y+c.y)/2;

    if (intersection (d,a,b) || intersection (d,a,c))
      answer += area;

    if (in_poly (d,a,b))
      solve (d,a,b,area/2);
    else if (in_poly(d,a,c))
      solve (d,a,c,area/2);
}

int main ()
{
    fin>>p.x>>p.y;
    O.x = 0;
    O.y = 0;
    point a;
    a.x = 10;
    a.y = 0;
    point b;
    b.x = 0;
    b.y = 0;
    point c;
    c.x = 10;
    c.y = 10;
    solve (a,b,c,25);
    fout<<fixed<<setprecision (6)<<answer;
}
